/*   $Id$      */
#ifndef SANCP_H
#include "sancp.h"
#endif
//#define DEBUG
/**************************************************************************
 ** Security Analyst Network Connection Profiler [sancp] - A TCP/IP statistical/collection tool
 * ************************************************************************
 * * Copyright (C) 2003-2007 John Curry <john.curry@metre.net>
 * *
 * * This program is distributed under the terms of version 1.0 of the
 * * Q Public License.  See LICENSE.QPL for further details.
 * *
 * * This program is distributed in the hope that it will be useful,
 * * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * *
 * ***********************************************************************/

void license();
void version();
struct acl *tacl_head=NULL, *tacl_tail=NULL;
//struct t_ports *tports[MAX_IP_PROTO];
void set_bpf_filter( char *);
char * get_tok(char **rule, const char * accept);
void parse_default(char *rule, char *accept);
char * get_next_tok(char **rule, const char *delimiters);
char *rev_search_vars(char *key, struct vars *var_head, int );

int fgetcline (char **buf, int size, FILE *fp){
        extern struct gvars gVars;
        int len;
	int c=0;
        if (fp== NULL){
		syslog(LOG_ERR,"Line: %i Invalid FILE handle\n",gVars.configlinenumber);
                return -1;
	}
        if (feof(fp)){
		syslog(LOG_ERR,"Line: %i Early END OF FILE\n",gVars.configlinenumber);
                return -1;
	}
        if (*buf == NULL){
                if( size == 0)
                        size=BUFSIZ;
                if((*buf = (char *)calloc(1,size)) == NULL){
			syslog(LOG_ERR,"Line: %i Out of memory\n",gVars.configlinenumber);
                        return -1;
		}
        }
        len=0;
//  Get characters until EOF or ';'
        while (((c = getc(fp)) != EOF) && c!='\n' && c!='\r'){
		if(c=='\\'){
                      if((c = getc(fp))==EOF){
				break;
		      }
		      if(c=='\n'){
			 c=' ';	
		      }else{
			ungetc(c,fp); 
			c='\\';
		      }
		}else{
		   if(c == ',' || c == '=' ) {
			c = ' ';
		   }
		}
                if(c == '#'){
	
		//
                // if comment mark, FF to end of line
		//

                        while( (c = getc(fp))!= EOF && c !='\n');
			//if(c=='\n'){ break;}
                        //if(c==EOF){ break; }
			break;
                }
                if(len+1 >= size) {
                        if(( *buf = (char *)realloc(*buf, size += BUFSIZ))==NULL){
			syslog(LOG_ERR,"Line: %i Out of memory\n",gVars.configlinenumber);
                                free(*buf);
                                return -1;
                        }
                }

		//
		// Make everything lower case for now
		// 	

		if(!(len==0 && (c==' ' || c=='\t'))) (*buf)[len++]=tolower(c);

               	if(c == '\t' || c == ' ' ){
			while( (c=fgetc(fp))!= EOF && c!='\n' && (c=='\t' || c==' '));
			if(c=='\n'|| c==EOF){ break; }
			// Trunicate comments
			if(c=='#') (*buf)[len]='\0'; 
			ungetc(c,fp); 
			// If we ran into a '#' sign, then just turn the last \t or space into a null.
		   	if(c == ',' || c == '=' ) {
				c = ' ';
			}
               	}
        }
        if (len == 0 && c == EOF){
		if(*buf!=NULL)
                	free(*buf);
                return -1;
        }
	if(len>0 && ((*buf)[len-1]==' ' || (*buf)[len-1]=='\t')){
	       	(*buf)[len-1]='\0'; 
	        return len-1;
	}else{
        	(*buf)[len++]='\0';
	        return len;
	}
}     

void parse_args(int argc, char *argv[])
{
	extern struct gvars gVars;
   	u_int64_t num;
	char *ftmp=0;
	//int ctr=0;
	for(int ctr=1; ctr < argc; ctr++)
	{
		if(strcmp(argv[ctr],"--config")==0)
		{
			// once we finished reading the config, we will print the schemas and exit
			gVars.print_config = 1;
		}else{
		if(strcmp(argv[ctr],"--schemas")==0)
		{
			// once we finished reading the config, we will print the schemas and exit
			gVars.print_schemas = 1;
		}else{
                if(strcmp(argv[ctr],"--noshift")==0)
		                       {
 			//  disable internal 2 byte shifting the packet read from file 
		        //  'any' interface 
                        gVars.shift = 0;
                }else{
                if(strcmp(argv[ctr],"--shift")==0)
		                       {
 			//  enable internal 2 byte shifting the packet read from file 
		        //  'any' interface 
                        gVars.shift = 1;
                }else{
		if(strcmp(argv[ctr],"-K")==0 || strcmp(argv[ctr],"--console")==0)
		{
			// enable console mode - log realtimes to 'console' or specified filename
			gVars.console_mode = 1;

		}else{
		if(strcmp(argv[ctr],"-D")==0 || strcmp(argv[ctr],"--daemon")==0)
		{
			// enable daemon mode
			gVars.daemon_mode = 1;
	                openlog(NAME,LOG_CONS,gVars.log_facility);
		}else{
		if(strcmp(argv[ctr],"-C")==0 || strcmp(argv[ctr],"--last_cnxid")==0)
		{
			// set last connection id to use - ~~~! Need to supply -d argument first !~~~
			if( ctr < argc-1 ){
				ctr++;
	                	ftmp=argv[ctr];
	                	num = (u_int64_t) strtoll(argv[ctr],&ftmp,0);
	                	if(argv[ctr]==ftmp)
	                	{
        	                	syslog(LOG_ERR,"Line: %i Format error, invalid last_cnxid: %s, using cnxid %llu\n",gVars.configlinenumber,argv[ctr],(long long unsigned)gVars.cnx_id);
	                	}else
				manage_cid(0);
				if(gVars.cnx_id>num){
        	                	syslog(LOG_ERR,"Line: %i cnxid provided (%llu) is less than 64bit cnxid in the '.cnxid' cache file, using cnxid %llu from cache instead\n",gVars.configlinenumber,num,(long long unsigned) gVars.cnx_id);
				}else{
        	                	syslog(LOG_ERR,"Line: %i Using cnxid provided (%llu) rather than the last cnxid in the '.cnxid' cache file (%llu)\n",gVars.configlinenumber,num,(long long unsigned) gVars.cnx_id);
					// Save the new cnx_id
					gVars.cnx_id=num;
					manage_cid(1);
				}
			}else{
				syslog(LOG_ERR,"Line: %i No cnxid provided with -C/--last_cnxid  option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
		if(strcmp(argv[ctr],"-i")==0)
		{
			// Set device name
			if( ctr < argc-1 ){
				if(gVars.default_device){ free(gVars.default_device); } ctr++;
				if( (gVars.default_device = (char *)calloc(strlen(argv[ctr])+ 1,1) ) ==NULL){
					syslog(LOG_ERR,"Line: %i Unable to allocate memory for -i option\n",gVars.configlinenumber);
					exit(0);
				}
				bcopy(argv[ctr],gVars.default_device,strlen(argv[ctr]));
				gVars.shift=0;	// disable shift (only needed for 'any' interface)
				if(strstr(gVars.default_device,DEFAULT_DEVICE))
					gVars.shift=1;	
			}else{
				syslog(LOG_ERR,"Line: %i No device name provided with -i option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
		if(strcmp(argv[ctr],"-d")==0)
		{
			// Set log directory name
			if( ctr < argc-1 ){
				if(gVars.log_directory){ free(gVars.log_directory); } ctr++;
				if( (gVars.log_directory = (char *)calloc(strlen(argv[ctr])+ 2,1) ) ==NULL){
					syslog(LOG_ERR,"Line: %i Unable to allocate memory for -d option\n",gVars.configlinenumber);
					exit(0);
				}
				bcopy(argv[ctr],gVars.log_directory,strlen(argv[ctr]));
				// We allocated an extra space for this...
				*(gVars.log_directory+strlen(argv[ctr]))='/';
			}else{
				syslog(LOG_ERR,"Line: %i No directory provided with -d option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
                if(strcmp(argv[ctr],"-p")==0)
                {
                        // Set pidfile name
                        if( ctr < argc-1 ){
                                if(gVars.pidfilename){ free(gVars.pidfilename); } ctr++;
                                if( (gVars.pidfilename = (char *)calloc(strlen(argv[ctr])+ 1,1) ) ==NULL){
                                        syslog(LOG_ERR,"Line: %i Unable to allocate memory for -p option\n",gVars.configlinenumber);
                                        exit(0);
                                }
                                bcopy(argv[ctr],gVars.pidfilename,strlen(argv[ctr]));
                        }else{
                                syslog(LOG_ERR,"Line: %i No pidfilename provided with -p option\n",gVars.configlinenumber);
                                exit(0);
                        }
                }else{
		if(strcmp(argv[ctr],"-r")==0)
		{
			// Set pcap input file name
			if( ctr < argc-1 ){
				if(gVars.input_filename){ free(gVars.input_filename); } ctr++;
				if( (gVars.input_filename = (char *)calloc(strlen(argv[ctr])+1,1) ) ==NULL){
					syslog(LOG_ERR,"Line: %i Unable to allocate memory for -r option\n",gVars.configlinenumber);
					exit(0);
				}
				bcopy(argv[ctr],gVars.input_filename,strlen(argv[ctr]));
				gVars.shift=0;	// disable shift (only needed for 'any' interface)
			}else{
				syslog(LOG_ERR,"Line: %i No pcap filename provided with -r option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
		if(strcmp(argv[ctr],"-c")==0)
		{
			// Set configuration directory name
			if( ctr < argc-1 ){
				if(gVars.config_file){ free(gVars.config_file); } ctr++;
				if( (gVars.config_file = (char *)calloc(strlen(argv[ctr])+1,1) ) ==NULL){
					syslog(LOG_ERR,"Line: %i Unable to allocate memory for -c option\n",gVars.configlinenumber);
					exit(0);
				}
				bcopy(argv[ctr],gVars.config_file,strlen(argv[ctr]));
			}else{
				syslog(LOG_ERR,"Line: %i No configuration filename provided with -c option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
		if(strcmp(argv[ctr],"--log-facility")==0)
		{
			// Set log facility
		    if( ctr < argc-1 ){
			ctr++;
			if(strcmp(argv[ctr],"LOCAL1")==0)
				gVars.log_facility = LOG_LOCAL1; 
			if(strcmp(argv[ctr],"LOCAL2")==0)
				gVars.log_facility = LOG_LOCAL2;
			if(strcmp(argv[ctr],"LOCAL3")==0)
				gVars.log_facility = LOG_LOCAL3;
			if(strcmp(argv[ctr],"LOCAL4")==0)
				gVars.log_facility = LOG_LOCAL4;
			if(strcmp(argv[ctr],"LOCAL5")==0)
				gVars.log_facility = LOG_LOCAL5;
			if(strcmp(argv[ctr],"LOCAL6")==0)
				gVars.log_facility = LOG_LOCAL6;
			if(strcmp(argv[ctr],"LOCAL7")==0)
				gVars.log_facility = LOG_LOCAL7;
		    }else{
			syslog(LOG_ERR,"Line: %i No value provided with --log-facility option\n",gVars.configlinenumber);
			exit(0);
		    }
		}else{
		if(strcmp(argv[ctr],"-u")==0)
		{
			// Set username name
		    if( ctr < argc-1 ){
			if(gVars.username){ free(gVars.username); gVars.username=0; } ctr++;
			if( (gVars.username = (char *)calloc(strlen(argv[ctr])+ 1,1) ) ==NULL){
				syslog(LOG_ERR,"Line: %i Unable to allocate memory for -u option\n",gVars.configlinenumber);
				exit(0);
			}
			bcopy(argv[ctr],gVars.username,strlen(argv[ctr]));
		    }else{
			syslog(LOG_ERR,"Line: %i No user provided with -u option\n",gVars.configlinenumber);
			exit(0);
		    }
		}else{
		if(strcmp(argv[ctr],"-g")==0)
		{
			// Set group name
		    if( ctr < argc-1 ){
			if(gVars.groupname){ free(gVars.groupname); gVars.groupname=0; } ctr++;
			if( (gVars.groupname = (char *)calloc(strlen(argv[ctr])+ 1,1) ) ==NULL){
				syslog(LOG_ERR,"Line: %i Unable to allocate memory for -g option\n",gVars.configlinenumber);
				exit(0);
			}
			bcopy(argv[ctr],gVars.groupname,strlen(argv[ctr]));
		    }else{
			syslog(LOG_ERR,"Line: %i No group provided with -g option\n",gVars.configlinenumber);
			exit(0);
		    }
		}else{
		if(strcmp(argv[ctr],"-F")==0)
		{
			// Set bp filter file name
			if( ctr < argc-1 ){
				ctr++;
				// We alloc mem here, but fileHandle will free it
				// This should be changed, but it works for now
				set_bpf_filter(argv[ctr]);
				syslog(LOG_INFO,"using file %s: %s\n",gVars.bpf_fname,argv[ctr]);
			//if(!gVars.daemon_mode)
				syslog(LOG_INFO,"enabling bpf filter from file %s: %s\n",gVars.bpf_fname,argv[ctr]);
			
			}else{
				syslog(LOG_ERR,"Line: %i No filename provided with -F option\n",gVars.configlinenumber);
				exit(0);
			}
		}else{
		if(strcmp(argv[ctr],"--strip_8021q")==0 || strcmp(argv[ctr],"--strip_8021Q")==0)
		{
			// enable removal of 8021Q header
			gVars.strip_8021Q = ENABLED;
			//if(!gVars.daemon_mode)
				syslog(LOG_INFO,"enabling stripping of 8021Q headers\n");
		}else{
		if(strcmp(argv[ctr],"--local-time")==0)
		{
			// disable GMT, enable localtime
			gVars.uselocaltime = 1;
			//if(!gVars.daemon_mode)
				syslog(LOG_INFO,"enabling local timestamps instead of GMT\n");
		}else{
		if(strcmp(argv[ctr],"-A")==0)
		{
			// enable recording all data to tcpdump file before
			// processing, any strip_8021Q option applies, however
			// FIX: added code to create rpfH pcapFileHandle
			if(gVars.rpfH){ gVars.rpfH->destroy(); gVars.rpfH=0; }
		        ftmp=createFileName(PCAP_RAW_FNAME,gVars.ph);
		        gVars.rpfH = new pcapFileHandle(ftmp,gVars.ph);
			free(ftmp);
			gVars.pcap_raw = ENABLED;
			syslog(LOG_INFO,"enabling debug recording of all pcap data to a tcpdump file\n");
		}else{
                if(strcmp(argv[ctr],"--index")==0)
                {
                        // enable index mode
                        gVars.cmdl_index_action = ACTION_LOG;
	                gVars.imode = OMODE_LOG;
	                gVars.index = OMODE_LOG;
                        syslog(LOG_INFO,"enabling default 'index' logging mode for quick access pcap file referencing\n");
                }else{
                if(strcmp(argv[ctr],"-R")==0)
                {
                        // disable realtime
                        gVars.cmdl_realtimes_action = ACTION_PASS;
	                gVars.rmode = OMODE_PASS;
                        syslog(LOG_INFO,"disabling default 'realtimes' logging mode\n");
                }else{
                if(strcmp(argv[ctr],"-P")==0)
                {
                        // disable default collect action
                        gVars.cmdl_pcap_action = ACTION_PASS;
                        gVars.pmode = OMODE_PASS;
                        syslog(LOG_INFO,"disabling default 'pcap' logging mode\n");

                }else{
                if(strcmp(argv[ctr],"-S")==0)
                {
                        // disable default log action
                        gVars.cmdl_stats_action = ACTION_PASS;
	                gVars.smode = OMODE_PASS;
                        syslog(LOG_INFO,"disabling default 'stats' logging mode\n");
                }else{
		if(strcmp(argv[ctr],"-a")==0 || strcmp(argv[ctr],"--enable-arprarp-decode")==0)
		{
			// enable  recording ARP/RARP hardware and protocol type to src and dst port fields
			// enable  recording ARP/RARP hardware and protocol length to src and dst bytes fields
			// enable  recording ARP/RARP operation type to ip_proto field
			// enable  recording ARP/RARP sender and target ip addresses to s_ip and d_ip fields
			gVars.arprarp_decode = ENABLED;
			syslog(LOG_INFO,"enabling logging arp/rarp ip addresses, operation to ip_proto, and hardware and protocol types/len to source and dest port/bytes fields\n");
		}else{
		if(strcmp(argv[ctr],"-I")==0 || strcmp(argv[ctr],"--enable-icmp-mixed")==0)
		{
			// enable  recording and tracking  ICMP type/code in src and dst port fields
			gVars.log_icmp_type_code = 1;
			syslog(LOG_INFO,"enabling logging icmp type/code for s_port and d_port fields\n");
		}else{
		if(strcmp(argv[ctr],"-B")==0)
		{
			// The rest of this line should be the bpf expression 
			if(gVars.bpf_filter){ free(gVars.bpf_filter); } ctr++;
			if(argc>ctr){
		       	 	gVars.bpf_filter=(char *) calloc(1,strlen(argv[ctr])+1);
		        	strncpy(gVars.bpf_filter,argv[ctr],strlen(argv[ctr]));
				syslog(LOG_INFO,"enabling bpf expression %s\n",gVars.bpf_filter);
			}	
			
		}else{
                if(strcmp(argv[ctr],"--use-pcap-time")==0)
                {
                        // enable use of pcap time instead of sigalarm to write stats to output files
  			gVars.use_pcap_time = ENABLED;
                        syslog(LOG_INFO,"enabling use of pcap time rather than system time for writing stats files\n");

                }else{

		if(strcmp(argv[ctr],"-HH")==0 || strcmp(argv[ctr],"--human-readable-header")==0)
		{
			// enable human readable header mode - affects initial row in stats and realtime outputfiles 
			gVars.human_readable_header = ENABLED;
			syslog(LOG_INFO,"enabling human readable headers for stats and realtimes\n");
			
		}else{
		if(strcmp(argv[ctr],"-H")==0 || strcmp(argv[ctr],"--human-readable")==0)
		{
			// enable human readable mode - affects IP addressess and tcp flag fields
			gVars.human_readable = 1;
			syslog(LOG_INFO,"enabling human readable connection logging\n");
			
		}else{
		if(strcmp(argv[ctr],"-V")==0||strcmp(argv[ctr],"-v")==0)
		{
			version();
			license();
			exit_all(0);
		}else{
		if(strcmp(argv[ctr],"-?")==0 || strcmp(argv[ctr],"-h")==0){
			version();
			usage();
			exit_all(0);
		}else{
			// See if this was a -option
			if(strstr(argv[ctr],"-")){
				syslog(LOG_ERR,"Line: %i skipping unrecognized option: %s\n",gVars.configlinenumber,argv[ctr]);
			
			}else{
		// The rest of this line should be the bpf expression 
			//if((argc-1)>(ctr++)){
				if(gVars.bpf_filter){ free(gVars.bpf_filter); gVars.bpf_filter=0; } 
		        	gVars.bpf_filter=(char *) calloc(1,strlen(argv[ctr])+1);
			        strncpy(gVars.bpf_filter,argv[ctr],strlen(argv[ctr]));
				syslog(LOG_INFO,"enabling bpf expression %s\n",gVars.bpf_filter);
				//syslog(LOG_ERR,"Line: %i Unknown option: %s\n",gVars.configlinenumber,argv[ctr]);
				}	
			//}
			
		}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
	}


}
void usage ()
{
	printf("see: src/HELP\n");
}
void build_config(int a){
	extern struct gvars gVars;
	gVars.configlinenumber=0;
	FILE *config_file;
	int size=0;
	int mylen=0;
 	char *rule=NULL;
	char *accept="\t ,=";
	struct vars *tmp_var=NULL;
	struct acl *tmp_acl=0;
	struct t_ports *ports_head;
	struct t_ports *tmp_port;
	int p=0;
	if(!gVars.config_file){ return; }
      	if((config_file=fopen(gVars.config_file,"r")) == NULL ) {
		return;
      	}
	// Drop the vars now
	while(gVars.var_head!=NULL){ tmp_var=gVars.var_head; gVars.var_head=gVars.var_head->next; if(tmp_var->key)free(tmp_var->key); if(tmp_var->value)free(tmp_var->value); free(tmp_var); } gVars.var_head=NULL;
	/* the first field should tell us everything we need to know about
	 * what to expect in the rule 
	 */
#ifdef DEBUG
	fprintf(stdout,"Reading config\n");
#endif
	while((mylen=fgetcline(&rule, size, config_file)) >= 0){	
		gVars.configlinenumber++;
		if(mylen<2){ 
#ifdef DEBUG
			fprintf(stdout,"Line: %d rule too small, skipping %s\n",gVars.configlinenumber, rule); 
#endif
		continue; }
#ifdef DEBUG
		fprintf(stdout,"Processing %s\n",rule);
#endif
		if(strncmp(rule,"format",6)==0)
		{
			parse_format(rule,accept);
		}
		else if(strncmp(rule,"known_ports",11)==0)
		{
			parse_known_ports(rule,gVars.var_head,accept);
		}
		else if(strncmp(rule,"default",7)==0)
		{
			parse_default(rule,accept);
		}else if(strncmp(rule,"var",3)==0)
		{
			parse_var(rule,accept);
#ifdef DEBUG
			if(gVars.var_head!=NULL)
			fprintf(stdout,"Have var, %s/%s\n",gVars.var_head->key,gVars.var_head->value);
#endif
		}else{
			parse_connection_rule(rule,gVars.var_head,accept);
		}
		if(rule){
#ifdef DEBUG
			printf("freeing %X\n",(u_int32_t) &rule);
#endif
			free(rule);
			rule=NULL;
		}
		
	}
	fclose(config_file);
#ifdef DEBUG
	printf("Done reading rules\n");
#endif
	// swap out old rules with new rules
	tmp_acl=gVars.acl_head;
	gVars.acl_head=tacl_head;
	tacl_head=tmp_acl;
#ifdef DEBUG
	printf("Disposing old rules\n");
#endif
	// dispose of previous rules
	while(tacl_head!=NULL){ tmp_acl=tacl_head; if(tmp_acl->fH){ tmp_acl->fH->destroy(); } tacl_head=tacl_head->next; free(tmp_acl);}
	tacl_head=NULL; tacl_tail=NULL;

#ifdef DEBUG
	printf("Disposing old ports\n");
#endif
	// dispose of previous ports
	for(p=0; p<MAX_IP_PROTO; p++)
	{
		ports_head=gVars.ports[p];
		
		while(ports_head!=NULL){ 
			tmp_port=ports_head;
			ports_head=tmp_port->next;
			free(tmp_port);
		}
		// Transfer new ports
		gVars.ports[p]=gVars.tports[p];

		// Remove previous reference
		gVars.tports[p]=NULL;
	}
	// Dispose of temporary rule variables 
	//
}	

void parse_format(const char *c_rule,const char *accept)
{
	extern struct gvars gVars;
	extern char fmtnames[MAXFLDS][MAXFLDSIZE];
	char *rule=(char *)calloc(1,strlen(c_rule)+1);
	memcpy(rule,c_rule,strlen(c_rule));
 	char *rules=rule;
	char *tok=0;
	if((tok = get_tok(&rules,accept))==NULL){
		syslog(LOG_ERR,"Line: %i Skipping, Invalid default, rule trunicated %s\n",gVars.configlinenumber,rule);
		return;
	}else if((tok = get_tok(&rules,accept))==NULL){
		syslog(LOG_ERR,"Line: %i Skipping, Invalid default, rule trunicated %s\n",gVars.configlinenumber,rule);
		return;
	}

	int type=0;
	if(strcmp(tok,"realtime")==0)
		type=1;
	if(strcmp(tok,"stats")==0)
		type=2;
	if(strcmp(tok,"console")==0)
		type=4;
	if(strcmp(tok,"index")==0)
		type=8;

	char delimiter=0;
	if(strncmp(rules,"delimiter",9)==0){
		if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid delimiter, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}else if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid delimiter, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}
		delimiter=tok[0];
		if(delimiter=='\\'){
			if(tok[1]=='s')
				delimiter=' ';
			if(tok[1]=='t')
				delimiter='\t';
			if(tok[1]=='n')
				delimiter='\n';
		}
	}

	char wildchar=0;
	if(strncmp(rules,"wildchar",8)==0){
		if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid wildchar, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}else if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid wildchar, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}
		wildchar=tok[0];
		if(wildchar=='\\'){
			if(tok[1]=='s')
				wildchar=' ';
			if(tok[1]=='t')
				wildchar='\t';
			if(tok[1]=='n')
				wildchar='\n';
		}
	}

	char eor=0;
	if(strncmp(rules,"eor",3)==0){
		if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid eor, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}else if((tok = get_tok(&rules,accept))==NULL){
			syslog(LOG_ERR,"Line: %i Skipping, Invalid eor, rule trunicated %s\n",gVars.configlinenumber,rule);
			return;
		}
		eor=tok[0];
		if(eor=='\\'){
			if(tok[1]=='s')
				eor=' ';
			if(tok[1]=='t')
				eor='\t';
			if(tok[1]=='n')
				eor='\n';
		}
	}

	char *tmpfldnames;
	u_int16_t col=0;
	u_int16_t icol=0;
	u_int16_t fmtval=0;
	char fmt[MAXFLDS];
	while(rules && (tok = get_tok(&rules,accept))!=NULL && *tok != 0)
	{
		tmpfldnames=(char *)fmtnames;
		while((fmtval<MAXFLDS) && strncmp(tmpfldnames,tok,MAXFLDSIZE)){
			/* keep track of the current index of fmtnames in fmtval */
			tmpfldnames+=MAXFLDSIZE; fmtval++;
		}
		/* if our index (fmtval) exceeds MAXFLDS then we have no more room in our fmt array */
		if(fmtval<MAXFLDS){
			fmt[col]=fmtval;
			col++;
		}else{
			syslog(LOG_ERR,"Line: %i Skipping, invalid format field name %s for column %d",gVars.configlinenumber,tok,icol);
		}
		if(col>MAXFLDS-1){
			syslog(LOG_ERR,"Line: %i Exceeded maximum columns allowed (%d), adjust MAXFLDS , skipping remaining format fields at column %d: %s",gVars.configlinenumber,MAXFLDS,icol,rules);
			break;
		}
		// if a sample format field is detected, enable memory intensive connection data sampling
		switch(fmtval){
		   case sample_dst_asc:
		   case sample_dst_hex:
		   case sample_src_asc:
		   case sample_src_hex:
			gVars.sampling_enabled=1;
			break;
		}
		icol++;
		fmtval=0;
	}
	if(type==1){
		if(gVars.realtime_fmt_len){
			free(gVars.realtime_fmt);
			gVars.realtime_fmt_len=0;
		}
		gVars.realtime_fmt=(char *) calloc(col,1);
		memcpy(gVars.realtime_fmt,fmt,col);
		gVars.realtime_fmt_len=col;
		if(wildchar)
			gVars.realtime_wildchar=wildchar;
		else
			gVars.realtime_wildchar=DEFAULT_NONPRINTABLE;
		if(eor)
			gVars.realtime_eor=eor;
		if(delimiter)
			gVars.realtime_delimiter=delimiter;
		if(gVars.rfH){ 
			gVars.rfH->setFormat(gVars.realtime_fmt,gVars.realtime_fmt_len); 
	                gVars.rfH->setEor(gVars.realtime_eor);
	                gVars.rfH->setWildchar(gVars.realtime_wildchar);
	                gVars.rfH->setDelimiter(gVars.realtime_delimiter);

		}
	}
	if(type==2){
		if(gVars.stats_fmt_len){
			free(gVars.stats_fmt);
			gVars.stats_fmt_len=0;
		}
		gVars.stats_fmt=(char *) calloc(col,1);
		memcpy(gVars.stats_fmt,fmt,col);
		gVars.stats_fmt_len=col;
		if(wildchar)
			gVars.stats_wildchar=wildchar;
		else
			gVars.stats_wildchar=DEFAULT_NONPRINTABLE;
		if(eor)
			gVars.stats_eor=eor;
		if(delimiter)
			gVars.stats_delimiter=delimiter;
		if(gVars.sfH){ 
			gVars.sfH->setFormat(gVars.stats_fmt,gVars.stats_fmt_len); 
	                gVars.sfH->setEor(gVars.stats_eor);
	                gVars.sfH->setWildchar(gVars.stats_wildchar);
	                gVars.sfH->setDelimiter(gVars.stats_delimiter);
		}
	}
	if(type==4){
		if(gVars.console_fmt_len){
			free(gVars.console_fmt);
			gVars.console_fmt_len=0;
		}
		gVars.console_fmt=(char *) calloc(col,1);
		memcpy(gVars.console_fmt,fmt,col);
		gVars.console_fmt_len=col;
		if(wildchar)
			gVars.console_wildchar=wildchar;
		else
			gVars.console_wildchar=DEFAULT_NONPRINTABLE;
		if(eor)
			gVars.console_eor=eor;
		if(delimiter)
			gVars.console_delimiter=delimiter;
		if(gVars.sdF){ 
			gVars.sdF->setFormat(gVars.console_fmt,gVars.console_fmt_len); 
	                gVars.sdF->setEor(gVars.console_eor);
	                gVars.sdF->setWildchar(gVars.console_wildchar);
	                gVars.sdF->setDelimiter(gVars.console_delimiter);
		}
	}
	if(type==8){
		if(gVars.index_fmt_len){
			free(gVars.index_fmt);
			gVars.index_fmt_len=0;
		}
		gVars.index_fmt=(char *) calloc(col,1);
		memcpy(gVars.index_fmt,fmt,col);
		gVars.index_fmt_len=col;
		if(wildchar)
			gVars.index_wildchar=wildchar;
		else
			gVars.index_wildchar=DEFAULT_NONPRINTABLE;
		if(eor)
			gVars.index_eor=eor;
		if(delimiter)
			gVars.index_delimiter=delimiter;
		if(gVars.ifH){ 
			gVars.ifH->setFormat(gVars.index_fmt,gVars.index_fmt_len); 
	                gVars.ifH->setEor(gVars.index_eor);
	                gVars.ifH->setWildchar(gVars.index_wildchar);
	                gVars.ifH->setDelimiter(gVars.index_delimiter);
		}
	}
	if(rule) free(rule);

}

void parse_default(char *c_rule,char *accept)
{
	extern struct gvars gVars;
        char *rule=(char *)calloc(1,strlen(c_rule)+1);
        memcpy(rule,c_rule,strlen(c_rule));
	char *rules=rule;
	char *tok=0;
	char *tmp=0;
	char *ftmp=0;
	char *pptr=0;

	if((tok = get_tok(&rules,accept))==NULL){
		syslog(LOG_ERR,"Line: %i Skipping, Invalid default, rule trunicated %s\n",gVars.configlinenumber,rule);
		free(rule);
		return;
	}else if((tok = get_tok(&rules,accept))==NULL){
		syslog(LOG_ERR,"Line: %i Skipping, Invalid default, rule trunicated %s\n",gVars.configlinenumber,rule);
		free(rule);
		return;
	}

       if(strcmp(tok,"sample_dst_length")==0)
       {
               if((tmp = get_tok(&rules,accept))==NULL)
               {
                       syslog(LOG_ERR,"Line: %i Format error, default sample_dst_length specified but none provided, using default sample_dst_length %d\n",gVars.configlinenumber,DEFAULT_EXPIRE_INTERVAL);
                       gVars.default_sample_length[FROM_TARGET] = DEFAULT_SAMPLE_LENGTH;
                       free(rule);
                       return;
               }
               pptr=tmp;
               gVars.default_sample_length[FROM_TARGET]= (u_int16_t) strtol(tmp,&pptr,0);
               if(tmp==pptr)
               {
                       syslog(LOG_ERR,"Line: %i Format error, invalid sample_dst_length %s, using default sample_dst_length  %d\n",gVars.configlinenumber,tmp,DEFAULT_SAMPLE_LENGTH);
               }
               free(rule);
               return;
       }
       if(strcmp(tok,"sample_src_length")==0)
       {
               if((tmp = get_tok(&rules,accept))==NULL)
               {
                       syslog(LOG_ERR,"Line: %i Format error, default sample_src_length specified but none provided, using default sample_src_length %d\n",gVars.configlinenumber,DEFAULT_EXPIRE_INTERVAL);
                       gVars.default_sample_length[FROM_INITIATOR] = DEFAULT_SAMPLE_LENGTH;
                       free(rule);
                       return;
               }
               pptr=tmp;
               gVars.default_sample_length[FROM_INITIATOR] = (u_int16_t) strtol(tmp,&pptr,0);
               if(tmp==pptr)
               {
                       syslog(LOG_ERR,"Line: %i Format error, invalid sample_src_length %s, using default sample_src_length  %d\n",gVars.configlinenumber,tmp,DEFAULT_SAMPLE_LENGTH);
               }
               free(rule);
               return;
       }

	if(strcmp(tok,"expire_interval")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default expire_interval specified but none provided, using default expire_interval %d\n",gVars.configlinenumber,DEFAULT_EXPIRE_INTERVAL);
			gVars.default_expire_interval = DEFAULT_EXPIRE_INTERVAL;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_expire_interval = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid expire_interval %s, using default expire_interval  %d\n",gVars.configlinenumber,tmp,DEFAULT_EXPIRE_INTERVAL);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"flush_interval")==0)
	{
		int reset_alarm=gVars.default_flush_interval;
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default flush_interval specified but none provided, using default flush_interval %d\n",gVars.configlinenumber,DEFAULT_FLUSH_INTERVAL);
			gVars.default_flush_interval = DEFAULT_FLUSH_INTERVAL;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_flush_interval = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid flush_interval %s, using default flush_interval  %d\n",gVars.configlinenumber,tmp,DEFAULT_FLUSH_INTERVAL);
		}
		// If the default flush_interval in the config file changed, we
		// need to reset the alarm to the new interval
#ifndef PLATFORM_SOLARIS
		if(reset_alarm && gVars.use_pcap_time == DISABLED){
			alarm(gVars.default_flush_interval);
		}
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"zone")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default zone specified but none provided, using default zone %d\n",gVars.configlinenumber,DEFAULT_ZONE);
			gVars.default_zone = DEFAULT_ZONE;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_zone = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid zone %s, using default zone %d\n",gVars.configlinenumber,tmp,DEFAULT_ZONE);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"node")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default node specified but none provided, using default node %d\n",gVars.configlinenumber,DEFAULT_NODE);
			gVars.default_node = DEFAULT_NODE;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_node = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid node %s, using default node %d\n",gVars.configlinenumber,tmp,DEFAULT_NODE);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"rid")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default rid specified but none provided, using default rid %d\n",gVars.configlinenumber,DEFAULT_RID);
			gVars.default_rid = DEFAULT_RID;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_rid = (u_int32_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid rid %s, using default rid %d\n",gVars.configlinenumber,tmp,DEFAULT_RID);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"rgid")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default rgid specified but none provided, using default rgid %d\n",gVars.configlinenumber,DEFAULT_RGID);
			gVars.default_rgid = DEFAULT_RGID;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_rgid = (u_int32_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid rid %s, using default rid %d\n",gVars.configlinenumber,tmp,DEFAULT_RID);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"status")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default status specified but none provided, using default status %d\n",gVars.configlinenumber,DEFAULT_STATUS);
			gVars.default_status = DEFAULT_STATUS;
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_status = (u_int8_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid status %s, using default status %d\n",gVars.configlinenumber,tmp,DEFAULT_STATUS);
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"use_icmp_mixed")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for use_icmp_mixed specified but no value provided %s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			gVars.log_icmp_type_code = ENABLED;
			syslog(LOG_INFO,"enabling logging icmp type/code for s_port and d_port fields\n");
		} 
		if(strcmp(tmp,"disable")==0) 
		{
			gVars.log_icmp_type_code = DISABLED;
			syslog(LOG_INFO,"disabling logging icmp type/code for s_port and d_port fields\n");
		} 
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"burst_mode")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for burst_mode specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			gVars.burst_mode = ENABLED;
			syslog(LOG_INFO,"enabling burst_mode\n");
		} 
		if(strcmp(tmp,"disable")==0) 
		{
			gVars.burst_mode = DISABLED;
			syslog(LOG_INFO,"disabling burst_mode\n");
		} 
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"debug_pcap_raw")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for debug_pcap_raw specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			// FIX: added code to create raw pcapFileHandle
			if(gVars.rpfH){ gVars.rpfH->destroy(); gVars.rpfH=0;  }
		        ftmp=createFileName("tcpdump");
		        gVars.rpfH = new pcapFileHandle(ftmp,gVars.ph);
			free(ftmp);
			gVars.pcap_raw = ENABLED;
			syslog(LOG_INFO,"enabling debug_pcap_raw\n");
		} 
		if(strcmp(tmp,"disable")==0) 
		{
			if(gVars.rpfH){ gVars.rpfH->destroy(); gVars.rpfH=0;  }
			gVars.pcap_raw = DISABLED;
			syslog(LOG_INFO,"disabling debug_pcap_raw\n");
		} 
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
			free(rule);
		return;
	}
	if(strcmp(tok,"arprarp_decode")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for decode_arprarp specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			gVars.arprarp_decode = ENABLED;
			syslog(LOG_INFO,"enabling logging arp/rarp ip addresses, operation to ip_proto, and hardware and protocol types/len to source and dest port/bytes fields\n");
		} 
		if(strcmp(tmp,"disable")==0) 
		{
			gVars.arprarp_decode = DISABLED; 
			syslog(LOG_INFO,"disabling logging arp/rarp ip addresses, operation to ip_proto, and hardware and protocol types/len to source and dest port/bytes fields\n");
		} 
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"use_pcap_time")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for use_pcap_time specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			gVars.use_pcap_time = ENABLED;
                        syslog(LOG_INFO,"enabling use of pcap time rather than system time for writing stats files\n");
		} 
		if(strcmp(tmp,"disable")==0) 
		{
			gVars.use_pcap_time = DISABLED;
                        syslog(LOG_INFO,"disabling use of pcap time rather than system time for writing stats files\n");
		} 
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"strip_8021q")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for strip_8021Q specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"enable")==0) 
		{
			gVars.strip_8021Q = ENABLED;
			syslog(LOG_INFO,"enabling stripping of 8021Q headers\n");
		}else{
		if(strcmp(tmp,"disable")==0) 
		{
			gVars.strip_8021Q = DISABLED;
			syslog(LOG_INFO,"disabling stripping of 8021Q headers\n");
		}else{
			syslog(LOG_ERR,"Line: %i Format error unknown option for strip_8021Q = %s\n",gVars.configlinenumber,tmp);

		} }
#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"pcapfilter")==0)
	{
		// We don't parse pcapfilter after initial startup, so see if we have an open pcap handle	
		if( gVars.ph!=0 ){ free(rule); return; }
		gVars.bpf_filter=(char *) calloc(1,strlen(rules)+1);
		strncpy(gVars.bpf_filter,rules,strlen(rules));
		syslog(LOG_INFO,"setting pcap filter expression %s\n",gVars.bpf_filter);

#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif	
		free(rule);
		return;
	}
        if(strcmp(tok,"console")==0)
        {
                if((tmp = get_tok(&rules,accept))==NULL)
                {
                        syslog(LOG_ERR,"Line: %i Format error, default for console specified but no value provided%s\n",gVars.configlinenumber,rule);
                        free(rule);
                        return;
                }
                if(strcmp(tmp,"filename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default filename for console specified but no value provided%s\n",gVars.configlinenumber, rule);
                                return;
                        }
                        if(gVars.console_fname){ free(gVars.console_fname); }
                        gVars.console_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.console_fname,tmp,strlen(tmp));
                }
	}
#ifdef ENABLE_PRELUDE_SUPPORT
	if(strcmp(tok,"prelude")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for prelude specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"log")==0) // log all matching traffic
		{
                        gVars.customoutput=OMODE_LOG;
		} 
		if(strcmp(tmp,"pass")==0) 
		{
                        gVars.customoutput=OMODE_PASS;
		} 

#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
#endif // ENABLE_PRELUDE_SUPPORT
	if(strcmp(tok,"stats")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for stats specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"log")==0) // log all matching traffic
		{
			if(gVars.sfH){ gVars.sfH->destroy(); gVars.sfH=0;  }
		        ftmp=createFileName(gVars.stats_fname);
		        gVars.sfH = new outputFileHandle((const char*)ftmp,gVars.stats_fmt,gVars.stats_fmt_len,APPEND_MODE,gVars.stats_fname);
			free(ftmp);
                        gVars.smode=OMODE_LOG;
		} 
		if(strcmp(tmp,"pass")==0) 
		{

			if(gVars.sfH){ gVars.sfH->destroy(); gVars.sfH=0; }
		        ftmp=createFileName(gVars.stats_fname);
		        gVars.sfH = new outputFileHandle((const char*)ftmp,gVars.stats_fmt,gVars.stats_fmt_len,APPEND_MODE,gVars.stats_fname);
			free(ftmp);
                        gVars.smode=OMODE_PASS;

		} 
                if(strcmp(tmp,"filename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default filename for stats specified but no value provided%s\n",gVars.configlinenumber,rule);
                                return;
                        }

                        if(gVars.stats_fname){ free(gVars.stats_fname);  gVars.stats_fname=0;}
                        gVars.stats_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.stats_fname,tmp,strlen(tmp));
                        gVars.smode=OMODE_FILENAME;
                        if(gVars.sfH){ gVars.sfH->destroy(); gVars.sfH=0; }
                        ftmp=createFileName(gVars.stats_fname,gVars.smode == OMODE_TSFILENAME);
		        gVars.sfH = new outputFileHandle((const char*)ftmp,gVars.stats_fmt,gVars.stats_fmt_len,APPEND_MODE,gVars.stats_fname);
                        gVars.sfH->setEor(gVars.stats_eor);
	                gVars.sfH->setWildchar(gVars.stats_wildchar);
                        gVars.sfH->setDelimiter(gVars.stats_delimiter);
                        free(ftmp);
                }
                if(strcmp(tmp,"tsfilename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default tsfilename for stats specified but no value provided%s\n",gVars.configlinenumber,rule);
				free(rule);
                                return;
                        }
                        if(gVars.stats_fname){ free(gVars.stats_fname); gVars.stats_fname=0; }
                        gVars.stats_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.stats_fname,tmp,strlen(tmp));
                        gVars.smode=OMODE_TSFILENAME;
                        if(gVars.sfH){ gVars.sfH->destroy(); gVars.sfH=0; }
                        ftmp=createFileName(gVars.stats_fname,gVars.smode == OMODE_TSFILENAME);
		        gVars.sfH = new outputFileHandle((const char*)ftmp,gVars.stats_fmt,gVars.stats_fmt_len,APPEND_MODE,gVars.stats_fname);
                        gVars.sfH->setEor(gVars.stats_eor);
	                gVars.sfH->setWildchar(gVars.stats_wildchar);
                        gVars.sfH->setDelimiter(gVars.stats_delimiter);
                        free(ftmp);
                }

#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"pcap")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for pcap specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"log")==0) // log all matching traffic
		{
			gVars.pmode = OMODE_LOG;
			gVars.pcap = OMODE_LOG;
			if(gVars.pcap_fname){ free(gVars.pcap_fname); gVars.pcap_fname=0; }
		        gVars.pcap_fname=(char *) calloc(1,strlen(PCAP_FNAME)+1);
		        strncpy(gVars.pcap_fname,PCAP_FNAME,strlen(PCAP_FNAME));
			// FIX: added code to recreate gVars.pfH pcapFileHandle
			if(gVars.pfH){ gVars.pfH->destroy(); gVars.pfH=0; }
		        ftmp=createFileName(gVars.pcap_fname);
		        gVars.pfH = new pcapFileHandle(ftmp,gVars.ph);
			free(ftmp);
		} 
		if(strcmp(tmp,"pass")==0) 
		{
			gVars.pmode=OMODE_PASS;
			gVars.pcap = OMODE_PASS;
			if(gVars.pcap_fname){ free(gVars.pcap_fname); }
		        gVars.pcap_fname=(char *) calloc(1,strlen(PCAP_FNAME)+1);
		        strncpy(gVars.pcap_fname,PCAP_FNAME,strlen(PCAP_FNAME));
			// FIX: added code to recreate gVars.pfH pcapFileHandle
			if(gVars.pfH){ gVars.pfH->destroy(); gVars.pfH=0; }
		        ftmp=createFileName(gVars.pcap_fname);
		        gVars.pfH = new pcapFileHandle(ftmp,gVars.ph);
		} 
		if(strcmp(tmp,"filename")==0)
		{
			if((tmp = get_tok(&rules,accept))==NULL)
			{
				syslog(LOG_ERR,"Line: %i Format error, default filename for pcap specified but no value provided%s\n",gVars.configlinenumber,rule);
				free(rule);
				return;
			}
			if(gVars.pcap_fname){ free(gVars.pcap_fname); gVars.pcap_fname=0; }
		        gVars.pcap_fname=(char *) calloc(1,strlen(tmp)+1);
		        strncpy(gVars.pcap_fname,tmp,strlen(tmp));
			gVars.pmode=OMODE_FILENAME;
                        gVars.pcap=OMODE_LOG;
			if(gVars.pfH){ gVars.pfH->destroy(); gVars.pfH=0; }
		        ftmp=createFileName(gVars.pcap_fname,gVars.pmode == OMODE_TSFILENAME );
		        gVars.pfH = new pcapFileHandle(ftmp,gVars.ph);
			free(ftmp);
		}
		if(strcmp(tmp,"tsfilename")==0)
		{
			if((tmp = get_tok(&rules,accept))==NULL)
			{
				syslog(LOG_ERR,"Line: %i Format error, default tsfilename for pcap specified but no value provided%s\n",gVars.configlinenumber,rule);
				free(rule);
				return;
			}
			if(gVars.pcap_fname){ free(gVars.pcap_fname); gVars.pcap_fname=0; }
		        gVars.pcap_fname=(char *) calloc(1,strlen(tmp)+1);
		        strncpy(gVars.pcap_fname,tmp,strlen(tmp));
			gVars.pmode=OMODE_TSFILENAME;
                        gVars.pcap=OMODE_LOG;
			if(gVars.pfH){ gVars.pfH->destroy(); gVars.pfH=0; }
		        ftmp=createFileName(gVars.pcap_fname,gVars.pmode == OMODE_TSFILENAME);
		        gVars.pfH = new pcapFileHandle(ftmp,gVars.ph);
			free(ftmp);
		}

#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to %s\n",tok,tmp);
#endif
		free(rule);
		return;
	}
        if(strcmp(tok,"index")==0)
        {
                if((tmp = get_tok(&rules,accept))==NULL)
                {
                        syslog(LOG_ERR,"Line: %i Format error, default for index specified but no value provided%s\n",gVars.configlinenumber,rule);
                        free(rule);
                        return;
                }
                if(strcmp(tmp,"log")==0) // log all matching traffic
                {
                        if(gVars.index_fname){ free(gVars.index_fname); gVars.index_fname=0;}
                        gVars.index_fname=(char *) calloc(1,strlen(INDEX_FNAME)+1);
                        strncpy(gVars.index_fname,INDEX_FNAME,strlen(INDEX_FNAME));
                        if(gVars.ifH){ gVars.ifH->destroy(); gVars.ifH=0;  }
                        ftmp=createFileName(gVars.index_fname);
                        gVars.ifH = new outputFileHandle((const char*)ftmp,gVars.index_fmt,gVars.index_fmt_len,APPEND_MODE,gVars.index_fname);
                        free(ftmp);
                        gVars.imode=OMODE_LOG;
                }
                if(strcmp(tmp,"pass")==0)
                {
                        if(gVars.index_fname){ free(gVars.index_fname); gVars.index_fname=0;}
                        gVars.index_fname=(char *) calloc(1,strlen(INDEX_FNAME)+1);
                        strncpy(gVars.index_fname,INDEX_FNAME,strlen(INDEX_FNAME));
                        if(gVars.ifH){ gVars.ifH->destroy(); gVars.ifH=0; }
                        ftmp=createFileName(gVars.index_fname);
                        gVars.ifH = new outputFileHandle((const char*)ftmp,gVars.index_fmt,gVars.index_fmt_len,APPEND_MODE,gVars.index_fname);
                        free(ftmp);
                        gVars.imode=OMODE_PASS;
                }
                if(strcmp(tmp,"filename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default filename for index specified but no value provided%s\n",gVars.configlinenumber,rule);
                                free(rule);
                                return;
                        }
                        if(gVars.index_fname){ free(gVars.index_fname); }
                        gVars.index_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.index_fname,tmp,strlen(tmp));
                        gVars.imode=OMODE_FILENAME;
                        gVars.index=OMODE_LOG;
                        ftmp=createFileName(gVars.index_fname,gVars.imode == OMODE_TSFILENAME);
                        gVars.ifH = new outputFileHandle((const char*)ftmp,gVars.index_fmt,gVars.index_fmt_len,APPEND_MODE,gVars.index_fname);
                        gVars.ifH->setEor(gVars.index_eor);
	                gVars.ifH->setWildchar(gVars.index_wildchar);
                        gVars.ifH->setDelimiter(gVars.index_delimiter);
                        free(ftmp);
                }
                if(strcmp(tmp,"tsfilename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default tsfilename for index specified but no value provided%s\n",gVars.configlinenumber,rule);
                                free(rule);
                                return;
                        }
                        if(gVars.index_fname){ free(gVars.index_fname); }
                        gVars.index_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.index_fname,tmp,strlen(tmp));
                        gVars.imode=OMODE_TSFILENAME;
                        gVars.index=OMODE_LOG;
                        if(gVars.ifH){ gVars.ifH->destroy(); gVars.ifH=0; }
                        ftmp=createFileName(gVars.index_fname,gVars.imode == OMODE_TSFILENAME);
                        gVars.ifH = new outputFileHandle((const char*)ftmp,gVars.index_fmt,gVars.index_fmt_len,APPEND_MODE,gVars.index_fname);
	                gVars.ifH->setWildchar(gVars.index_wildchar);
                        gVars.ifH->setEor(gVars.index_eor);
                        gVars.ifH->setDelimiter(gVars.index_delimiter);
                        free(ftmp);
                }

#ifdef DEBUG
                fprintf(stdout,"Setting default for %s to '%s'\n",tok,tmp);
#endif
                free(rule);
                return;
        }
	if(strcmp(tok,"realtime")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default for realtime specified but no value provided%s\n",gVars.configlinenumber,rule);
			free(rule);
			return;
		}
		if(strcmp(tmp,"log")==0) // log all matching traffic
		{
                        if(gVars.realtime_fname){ free(gVars.realtime_fname); gVars.realtime_fname=0;}
		        gVars.realtime_fname=(char *) calloc(1,strlen(REALTIME_FNAME)+1);
		        strncpy(gVars.realtime_fname,REALTIME_FNAME,strlen(REALTIME_FNAME));
			if(gVars.rfH){ gVars.rfH->destroy(); gVars.rfH=0;  }
		        ftmp=createFileName(gVars.realtime_fname);
		        gVars.rfH = new outputFileHandle((const char*)ftmp,gVars.realtime_fmt,gVars.realtime_fmt_len,APPEND_MODE,gVars.realtime_fname);
			free(ftmp);
                        gVars.rmode=OMODE_LOG;
		} 
		if(strcmp(tmp,"pass")==0) 
		{
                        if(gVars.realtime_fname){ free(gVars.realtime_fname); gVars.realtime_fname=0;}
		        gVars.realtime_fname=(char *) calloc(1,strlen(REALTIME_FNAME)+1);
		        strncpy(gVars.realtime_fname,REALTIME_FNAME,strlen(REALTIME_FNAME));
			if(gVars.rfH){ gVars.rfH->destroy(); gVars.rfH=0; }
		        ftmp=createFileName(gVars.realtime_fname);
		        gVars.rfH = new outputFileHandle((const char*)ftmp,gVars.realtime_fmt,gVars.realtime_fmt_len,APPEND_MODE,gVars.realtime_fname);
			free(ftmp);
                        gVars.rmode=OMODE_PASS;
		} 
                if(strcmp(tmp,"filename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default filename for realtime specified but no value provided%s\n",gVars.configlinenumber,rule);
				free(rule);
                                return;
                        }
                        if(gVars.realtime_fname){ free(gVars.realtime_fname); }
                        gVars.realtime_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.realtime_fname,tmp,strlen(tmp));
                        gVars.rmode=OMODE_FILENAME;
                        gVars.realtime=OMODE_LOG;
                        ftmp=createFileName(gVars.realtime_fname,gVars.rmode == OMODE_TSFILENAME);
		        gVars.rfH = new outputFileHandle((const char*)ftmp,gVars.realtime_fmt,gVars.realtime_fmt_len,APPEND_MODE,gVars.realtime_fname);
                        gVars.rfH->setEor(gVars.realtime_eor);
	                gVars.rfH->setWildchar(gVars.realtime_wildchar);
                        gVars.rfH->setDelimiter(gVars.realtime_delimiter);
                        free(ftmp);
                }
                if(strcmp(tmp,"tsfilename")==0)
                {
                        if((tmp = get_tok(&rules,accept))==NULL)
                        {
                                syslog(LOG_ERR,"Line: %i Format error, default tsfilename for realtime specified but no value provided%s\n",gVars.configlinenumber,rule);
				free(rule);
                                return;
                        }
                        if(gVars.realtime_fname){ free(gVars.realtime_fname); }
                        gVars.realtime_fname=(char *) calloc(1,strlen(tmp)+1);
                        strncpy(gVars.realtime_fname,tmp,strlen(tmp));
                        gVars.rmode=OMODE_TSFILENAME;
                        gVars.realtime=OMODE_LOG;
                        if(gVars.rfH){ gVars.rfH->destroy(); gVars.rfH=0; }
                        ftmp=createFileName(gVars.realtime_fname,gVars.rmode == OMODE_TSFILENAME);
		        gVars.rfH = new outputFileHandle((const char*)ftmp,gVars.realtime_fmt,gVars.realtime_fmt_len,APPEND_MODE,gVars.realtime_fname);
                        gVars.rfH->setEor(gVars.realtime_eor);
	                gVars.rfH->setWildchar(gVars.realtime_wildchar);
                        gVars.rfH->setDelimiter(gVars.realtime_delimiter);
                        free(ftmp);
                }

#ifdef DEBUG
		fprintf(stdout,"Setting default for %s to '%s'\n",tok,tmp);
#endif
		free(rule);
		return;
	}
	if(strcmp(tok,"limit")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, limit specified but none provided, using default limit %d\n",gVars.configlinenumber,DEFAULT_LIMIT);
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_limit = (u_int64_t) strtoll(tmp,&pptr,0);
		if(tmp==pptr)	
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid limit %s, using default limit %d\n",gVars.configlinenumber,tmp,DEFAULT_LIMIT);
			gVars.default_limit = DEFAULT_LIMIT;
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"timeout")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, default timeout specified but none provided, using timeout value %d\n",gVars.configlinenumber,DEFAULT_TIMEOUT);
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_timeout = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid timeout %s, using default timeout %d\n",gVars.configlinenumber,tmp,DEFAULT_TIMEOUT);
			gVars.default_timeout = DEFAULT_TIMEOUT;
		}
		free(rule);
		return;
	}
	if(strcmp(tok,"tcplag")==0)
	{
	 	if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, tcplag specified but none provided, using tcplag value %d\n",gVars.configlinenumber,DEFAULT_LAG);
			free(rule);
			return;
		}
		pptr=tmp;
		gVars.default_tcplag = (u_int16_t) strtol(tmp,&pptr,0);
		if(tmp==pptr)
		{
			syslog(LOG_ERR,"Line: %i Format error, invalid tcplag %s, using default tcplag %d\n",gVars.configlinenumber,tmp,DEFAULT_LAG);
			gVars.default_tcplag = DEFAULT_LAG;
		}
		free(rule);
		return;

	}
        if(strcmp(tok,"nosrc_pktsok")==0)
        {
                if((tmp = get_tok(&rules,accept))==NULL)
                {
                        syslog(LOG_ERR,"Line: %i Format error, nosrc_pktsok specified but none provided, using nosrc_pktsok value %d\n",gVars.configlinenumber,DEFAULT_NOSRC_PKTSOK);
                        free(rule);
                        return;
                }
                pptr=tmp;
                gVars.default_nosrc_pktsok = strtol(tmp,&pptr,0) ? 1 : 0 ;
                if(tmp==pptr)
                {
                        syslog(LOG_ERR,"Line: %i Format error, invalid nosrc_pktsok %s, using default nosrc_pktsok %d\n",gVars.configlinenumber,tmp,DEFAULT_NOSRC_PKTSOK);
                        gVars.default_nosrc_pktsok = DEFAULT_NOSRC_PKTSOK;
                }
                free(rule);
                return;

	}

#ifdef ENABLE_PRELUDE_SUPPORT

	if(strcmp(tok,"prelude_impact_severity")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, prelude_impact_severity specified but none provided, using prelude_impact_severity %s\n",gVars.configlinenumber,PRELUDE_IMPACT_SEVERITY);
			free(rule);
			return;
		}
		gVars.prelude_impact_severity = strdup(tmp);
		free(rule);
		return;
	}
	if(strcmp(tok,"prelude_impact_completion")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, prelude_impact_completion specified but none provided, using prelude_impact_completion %s\n",gVars.configlinenumber,PRELUDE_IMPACT_COMPLETION);
			free(rule);
			return;
		}
		gVars.prelude_impact_completion = strdup(tmp);
		free(rule);
		return;
	}
	if(strcmp(tok,"prelude_impact_type")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, prelude_impact_type specified but none provided, using prelude_impact_type %s\n",gVars.configlinenumber,PRELUDE_IMPACT_TYPE);
			free(rule);
			return;
		}
		gVars.prelude_impact_type = strdup(tmp);
		free(rule);
		return;
	}
	if(strcmp(tok,"prelude_confidence_rating")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, prelude_confidence_rating specified but none provided, using prelude_confidence_rating %s\n",gVars.configlinenumber,PRELUDE_CONFIDENCE_RATING);
			free(rule);
			return;
		}
		gVars.prelude_confidence_rating = strdup(tmp);
		free(rule);
		return;
	}
	if(strcmp(tok,"prelude_profile")==0)
	{
		if((tmp = get_tok(&rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Format error, prelude_profile specified but none provided, using prelude_profile %s\n",gVars.configlinenumber,PRELUDE_PROFILE);
			free(rule);
			return;
		}
		gVars.profile = strdup(tmp);
		free(rule);
		return;
	}
#endif

#ifdef DEBUG
	fprintf(stdout,"Didn't set default for %s to %s\n",tok,tmp);
#endif
}

void parse_var(char *c_rule, char *accept)
{
	extern struct gvars gVars;
        char *rule=(char *)calloc(1,strlen(c_rule)+1);
        memcpy(rule,c_rule,strlen(c_rule));
        char **rules=&rule;
	char *tok=NULL;
	struct vars *n_var;
	rules=&rule;

        	if((n_var=(struct vars *)calloc(1,sizeof(struct vars)))==NULL){ printf ("Out of Memory?\n"); return;}
			
		n_var->key=NULL;
		n_var->value=NULL;
		n_var->next=NULL;
		if((tok = get_tok(rules,accept))==NULL || strcmp(tok,"var")!=0)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting var type %s\n",gVars.configlinenumber,rule);
			free(n_var);
			free(rule);
			return;
		}
		else
		{
			if((tok = get_tok(rules,accept))==NULL)
			{
				syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting var key %s\n",gVars.configlinenumber,rule);
				free(n_var);
				free(rule);
				return;
			}
			else
			{
        			if((n_var->key=(char *)calloc(1,sizeof(char)*strlen(tok)+1))==NULL){ printf ("Out of Memory?\n"); free(n_var); free(rule); return;}
				strncpy(n_var->key,tok,sizeof(char)*strlen(tok));

				if((tok = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting var value %s\n",gVars.configlinenumber,rule);
					free(n_var->key);
					n_var->key=NULL; free(n_var);
					free(rule);
					return;
				}
				else
				{
        				if((n_var->value=(char *)calloc(1,sizeof(char)*strlen(tok)+1))==NULL){ printf ("Out of Memory?\n"); free(n_var->key); free(n_var); free(rule); return;}
					strncpy(n_var->value,tok,sizeof(char)*strlen(tok));
				}
			}
		}

		// If we made it this var, then we have a valid var
		if(!gVars.var_head){
			gVars.var_head=n_var;
		}
		else
		{
			n_var->next = gVars.var_head;
			gVars.var_head=n_var;
		}
		free(rule);
}


//
// Search for key, set vclass and return value 
//

char *search_vars(char *key, struct vars *var_head,  int vclass)
{
	struct vars *tmp;
       	tmp = var_head;
#ifdef DEBUG
	extern struct gvars gVars;
	syslog(LOG_ERR,"Line: %i Searching for key '%s'\n",gVars.configlinenumber,key);
#endif
	while(tmp!=NULL)
	{
#ifdef DEBUG
		fprintf(stdout,"search_vars: Checking key/value (%d) '%s'/'%s' for (%d) '%s'\n",strlen(tmp->key),tmp->key,tmp->value,strlen(key),key);
#endif
		if(strcmp(tmp->key,key)==0)
		{
#ifdef DEBUG
			syslog(LOG_ERR,"Line: %i Found key/value %s/%s\n",gVars.configlinenumber,key,tmp->value);
#endif			
			// Mark the variable class that we were looking in
			// so we will 'remember' which values pertain to which 
			// class of keys when we do a reverse lookup later.
			// i.e. The value of 8 may exist in two or more classes
			// Different class variables, having the same name, may 
			// cause undefined results.
			tmp->vclass=vclass;	
			return tmp->value;
		}
		tmp=tmp->next;
	}
#ifdef DEBUG
	fprintf(stdout,"search_vars: Key not found '%s'\n",key);
#endif
	return NULL;
}


//
// Return value for key in requested vclass
//

char *rev_search_vars(char *value, struct vars *var_head, int vclass)
{
	struct vars *tmp;
       	tmp = var_head;
#ifdef DEBUG
	extern struct gvars gVars;
	syslog(LOG_INFO,"rev_search_vars: Search %d:'%s' for %d:'%s'\n",tmp->vclass,tmp->value,vclass,value);
#endif
	while(tmp!=NULL)
	{
		//if( strcmp(tmp->value,value)==0)
		if( strcmp(tmp->value,value)==0 && ( tmp->vclass==vclass ))
		{
#ifdef DEBUG
			syslog(LOG_ERR,"rev_search_vars: Line: %i Found key/value %s/'%s'\n",gVars.configlinenumber,tmp->key,tmp->value);
#endif			
			return tmp->key;
		}
		tmp=tmp->next;
	}
#ifdef DEBUG
	fprintf(stdout,"rev_search_vars: Value not found '%s'\n",value);
#endif
	return NULL;
}

void parse_known_ports(char *rule, struct vars *var_head, char *accept)
{
	extern struct gvars gVars;
	//extern struct t_ports *tports[MAX_IP_PROTO];
	char *tmp=NULL, *pptr=NULL,*tok=NULL;
 	char **rules=NULL;
	struct t_ports *n_ports=NULL;
	int proto = 0;
	char ptok[256];
	u_int16_t port_h=0;
	u_int16_t port_l=0;
	rules=&rule;

		//
		//  Get protocol value
		//
			
		if((tok = get_tok(rules,accept))!=NULL)
		{

			if((tok = get_tok(rules,accept))==NULL)
			{
				syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting ports protocol %s\n",gVars.configlinenumber,rule);
				return;
			}

			//
			// Translate protocol name to value
			//

	    		if((tmp=search_vars(tok, var_head, VCLASS_2))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}

			pptr=tok;

			proto = (u_int8_t) strtol(tok,&pptr,0);

			if(tok==pptr)
			{
				syslog(LOG_ERR,"Line: %i Skipping, Invalid protocol value found: %s\n",gVars.configlinenumber,tok);
				return;
			}

			//
			// Get each port
			//

			while((tok = get_tok(rules,accept))!=NULL && *tok != 0)
			{

			   //
			   //  Split port ranges
			   //

			   if((tmp=rev_search_vars(tok,gVars.var_head,VCLASS_3))==NULL){

				//
				//  Translate port name to value 
				//	

	    		        if((tmp=search_vars(tok,var_head,VCLASS_3))!=NULL)
			        {
			            bzero(ptok,256);
			            strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			            tok=ptok;
		   	        }
			   }


				if((tmp = get_next_tok(&tok,"-"))!=NULL)
				{
					pptr=tmp;
					port_l = (u_int16_t) strtol(tmp,&pptr,0);
					if(tmp==pptr)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid port start of range found: %s\n",gVars.configlinenumber,tmp);
						return;
					}
					pptr=tok;
					port_h = (u_int16_t) strtol(tok,&pptr,0);
					if(tok==pptr)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid port end of range found: %s\n",gVars.configlinenumber,tok);
						return;
					}
				}else{
#ifdef DEBUG					
					syslog(LOG_ERR,"Line: %i single Port found: %s\n",gVars.configlinenumber,tok);
#endif					
					pptr=tok;
					port_l = (u_int16_t) strtol(tok,&pptr,0);
					if(tok==pptr)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid port found: %X.\n",gVars.configlinenumber,*tok);
						return;
					}
					port_h=port_l;
				}


				//
				//  If we made it this far we have a valid oort
				//

        			if((n_ports=(struct t_ports *)calloc(1,sizeof(struct t_ports)))==NULL){ printf ("Out of Memory?\n"); return;}
#ifdef DEBUG					
					syslog(LOG_ERR,"Line: %i Port added: %d-%d\n",gVars.configlinenumber,port_l,port_h);
#endif					

				n_ports->h_port=port_h;
				n_ports->l_port=port_l;
				n_ports->next=NULL;

				if(!gVars.tports[proto])
				{
#ifdef DEBUG					
					syslog(LOG_ERR,"Line: %i First Port added to list %d: %d-%d\n",gVars.configlinenumber,proto,port_l,port_h);
#endif					
					gVars.tports[proto]=n_ports;
				}
				else
				{
#ifdef DEBUG					
					syslog(LOG_ERR,"Line: %i Port added to list %d: %d-%d\n",gVars.configlinenumber,proto,port_l,port_h);
#endif					
					n_ports->next = gVars.tports[proto];
					gVars.tports[proto]=n_ports;

				}

			}

		}else{

			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting ports protocol %s\n",gVars.configlinenumber,rule);

		}
}

void parse_connection_rule(char *rule, struct vars *var_head, char *accept)
{
	// THIS FUNCTION DOES NOT EXIT THE PROGRAM WHEN IT RECEIVES A
	// BAD RULE!!! THIS IS DONE TO ENSURE THIS TOOL CONTINUES COLLECTION
	// SPECIFICALLY IN CASE IT READS A BAD CONFIGURATION FILE AFTER RECEIVING
	// A KILL -HUP SIGNAL - SO ALWAYS CHECK THE SYSLOG FOR ERRORS
	// IF THE DEFAULT PCAP MODE IS TO RECORD EVERYTHING THEN BAD RULES WILL
	// NOT MEAN LOST DATA.  YOU CAN ALWAYS RE-PROCESS PCAP DATA BUT CAN'T 
	// RECOVER FROM DATA YOU DIDN'T RECORD
	char *tmp, *tok=NULL;
 	char **rules=NULL;
	char *pptr=NULL;
	char *ftmp=0;
	char ptok[256];
        struct acl *n_acl;
	extern struct gvars gVars;
        extern struct acl *tacl_head, *tacl_tail;
	bzero(ptok,256);
	rules=&rule;
        	if((n_acl=(struct acl *)calloc(1,sizeof(struct acl)))==NULL){ syslog (LOG_CRIT,"Unable to allocate ACL - Out of Memory!\n"); return;}
		bzero(n_acl,sizeof(struct acl));
		n_acl->next=NULL;
		n_acl->cmode = CMODE_BOTH;
		n_acl->pcap = gVars.pmode?1:0;
		n_acl->pmode = gVars.pmode;
		n_acl->stats = gVars.smode?1:0; 
		n_acl->smode = gVars.smode; 
		n_acl->realtime = gVars.rmode?1:0;
		n_acl->index = gVars.imode?1:0;
		n_acl->rmode = gVars.rmode; 
		n_acl->timeout = gVars.default_timeout;
		n_acl->limit = gVars.default_limit;
		n_acl->status = gVars.default_status;
		n_acl->rid = gVars.default_rid;
		n_acl->tcplag = gVars.default_tcplag;
		n_acl->nosrc_pktsok = gVars.default_nosrc_pktsok;
		if(gVars.pfH && gVars.pmode){
			n_acl->fH = gVars.pfH->attach();
		}else{
			n_acl->fH = 0;
		}
#ifdef ENABLE_PRELUDE_SUPPORT
		n_acl->customoutput = 1;
		n_acl->prelude_profile = gVars.prelude_profile;
		n_acl->prelude_impact_severity=gVars.prelude_impact_severity;
		n_acl->prelude_impact_type=gVars.prelude_impact_type;
		n_acl->prelude_impact_completion=gVars.prelude_impact_completion;
		n_acl->prelude_confidence_rating=gVars.prelude_confidence_rating;
#endif

		// FIELD 0 - required - Get the h_proto
                n_acl->h_proto_h = 0xFFFF;
                n_acl->h_proto_l = 0x0000;
		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting hw protocol %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){
	    		if((tmp=search_vars(tok,gVars.var_head,VCLASS_0))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}

			if((tmp = get_next_tok(&tok,"-"))!=NULL)
			{		
				pptr=tmp;
				n_acl->h_proto_l = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid start of h_proto range found: %s\n",gVars.configlinenumber,tmp);
					free(n_acl); return;
				}
				pptr=tok;
				n_acl->h_proto_h = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid end of h_proto range found: %s\n",gVars.configlinenumber,tok);
					free(n_acl); return;
				}
			}else{		
				pptr=tok;
				n_acl->h_proto_l = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid h_protocol value found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
				n_acl->h_proto_h = n_acl->h_proto_l;
			}
		}
			
		// FIELD 1 - required - Get the source address and mask fields
                n_acl->s_mask=0xFFFFFFFF;
                n_acl->s_ip=0x00000000;
			
		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting source address and mask %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){
		    	if((tmp=search_vars(tok,gVars.var_head,VCLASS_1))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}
			
			if((tmp = get_next_tok(&tok,"/"))!=NULL)
			{
				if(inet_aton(tmp,(struct in_addr *)&n_acl->s_ip)==0)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid source address found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
					free(n_acl);
					return;
				}
				if(strstr(tok,"."))
				{
					if(inet_aton(tok,(struct in_addr *)&n_acl->s_mask)==0)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid source mask found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
						free(n_acl);
						return;
					}
				}
				else
				{
					pptr=tok;
					n_acl->s_mask=htonl(0xFFFFFFF<<(32-(u_int8_t)(strtol(tok,&pptr,0))));
					if(tok==pptr)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid source mask found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
						free(n_acl);
						return;
					}
				}
			}else{
				if(inet_aton(tok,(struct in_addr *)&n_acl->s_ip)==0)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid source address found: %s %s\n",gVars.configlinenumber,tok,rule);
					free(n_acl);
					return;
				}
			}
		}		
		// FIELD 3 - required - Get the destination address and mask fields

                n_acl->d_mask=0xFFFFFFFF;
                n_acl->d_ip=0x00000000;
			
		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting destination address and mask %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){
			if((tmp=search_vars(tok,gVars.var_head,VCLASS_1))!=NULL)
			{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
			}
			if((tmp = get_next_tok(&tok,"/"))!=NULL)
			{
				if(inet_aton(tmp,(struct in_addr *)&n_acl->d_ip)==0)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid destination address found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
					free(n_acl);
					return;
				}
				if(strstr(tok,"."))
				{
					if(inet_aton(tok,(struct in_addr *)&n_acl->d_mask)==0)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid destination mask found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
						free(n_acl);
						return;
					}
				}
				else
				{
					pptr=tok;
					n_acl->d_mask=htonl(0xFFFFFFFF<<(32-(u_int8_t)(strtol(tok,&pptr,0))));
					if(tok==pptr)
					{
						syslog(LOG_ERR,"Line: %i Skipping, Invalid destination mask found: %s/%s %s\n",gVars.configlinenumber,tmp,tok,rule);
						free(n_acl);
						return;
					}
				}
			}else{
				if(inet_aton(tok,(struct in_addr *)&n_acl->d_ip)==0)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid destination address found: %s %s\n",gVars.configlinenumber,tok,rule);
					free(n_acl);
					return;
				}
			}
		}
			
		// FIELD 4 - required - Get the protocol field

		n_acl->proto_l = 0x00;
		n_acl->proto_h = 0xFF;

		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting protocol %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){
		    	if((tmp=search_vars(tok,gVars.var_head,VCLASS_2))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}

			// Use the defaults for ANY
			if((tmp = get_next_tok(&tok,"-"))!=NULL)
			{		
				pptr=tmp;
				n_acl->proto_l = (u_int8_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid start of proto range found: %s\n",gVars.configlinenumber,tmp);
					free(n_acl); return;
				}
				pptr=tok;
				n_acl->proto_h = (u_int8_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid end of proto range found: %s\n",gVars.configlinenumber,tok);
					free(n_acl); return;
				}
			}else{		
				pptr=tok;
				n_acl->proto_l = (u_int8_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid protocol value found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
				n_acl->proto_h = n_acl->proto_l;
			}
		}

		// FIELD 5 - required - Get the source ports field

                n_acl->s_port_l=0x0000;
                n_acl->s_port_h=0xFFFF;

		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting source ports %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){
		    	if((tmp=search_vars(tok,gVars.var_head,VCLASS_3))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}

			// Use the defaults for ANY
			if((tmp = get_next_tok(&tok,"-"))!=NULL)
			{		
				pptr=tmp;
				n_acl->s_port_l = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid source port start of range found: %s\n",gVars.configlinenumber,tmp);
					free(n_acl);
					return;
				}
				pptr=tok;
				n_acl->s_port_h = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid source port end of range found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
			}else{
				pptr=tok;
				n_acl->s_port_l = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid source port found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
				n_acl->s_port_h=n_acl->s_port_l;
			}
		}
		// FIELD 6 - required - Get the destination ports field

                n_acl->d_port_l=0x0000;
                n_acl->d_port_h=0xFFFF;

		if((tok = get_tok(rules,accept))==NULL)
		{
			syslog(LOG_ERR,"Line: %i Skipping, Invalid rule trunicated when expecting destination ports %s\n",gVars.configlinenumber,rule);
			free(n_acl);
			return;
		}
		else if(strcmp(tok,"any")){

				
		    	if((tmp=search_vars(tok,gVars.var_head,VCLASS_3))!=NULL)
		    	{
			    bzero(ptok,256);
			    strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			    tok=ptok;
		    	}

			if((tmp = get_next_tok(&tok,"-"))!=NULL )
			{
				pptr=tmp;
				n_acl->d_port_l = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid destination port start of range found: %s\n",gVars.configlinenumber,tmp);
					free(n_acl);
					return;
				}
				pptr=tok;
				n_acl->d_port_h = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid destination port end of range found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
			}else{
				pptr=tok;
				n_acl->d_port_l = (u_int16_t) strtol(tok,&pptr,0);
				if(tok==pptr)
				{
					syslog(LOG_ERR,"Line: %i Skipping, Invalid destination port found: %s\n",gVars.configlinenumber,tok);
					free(n_acl);
					return;
				}
				n_acl->d_port_h=n_acl->d_port_l;
			}
		}

		// REMAINING FIELDs - not required  - limit and timeout

		while((tok = get_tok(rules,accept))!=NULL && *tok!=0 )
		{
			if(strcmp(tok,"rid")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, rid specified but none provided, using default rid %u\n",gVars.configlinenumber,gVars.default_rid);
					return;
				}
		    		if((tok=search_vars(tmp,gVars.var_head,VCLASS_4))!=NULL)
			    	{
				    bzero(ptok,256);
				    strncpy(ptok,tok,sizeof(char)*strlen(tok));
				    tmp=ptok;
			    	}
				pptr=tmp;
				n_acl->rid = (u_int32_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)	
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid rid %s, using default rid %u\n",gVars.configlinenumber,tmp,gVars.default_rid);
					// Let's restore the delimiter and put back our token 
					// this might be the next option
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}
                        if(strcmp(tok,"rgid")==0)
                        {
                                if((tmp = get_tok(rules,accept))==NULL)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, rgid specified but none provided, using default rgid %u\n",gVars.configlinenumber,gVars.default_rgid);
                                        return;
                                }
		    		if((tok=search_vars(tmp,gVars.var_head,VCLASS_5))!=NULL)
			    	{
				    bzero(ptok,256);
				    strncpy(ptok,tok,sizeof(char)*strlen(tok));
				    tmp=ptok;
			    	}
                                pptr=tmp;
                                n_acl->rgid = (u_int32_t) strtol(tmp,&pptr,0);
                                if(tmp==pptr)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, invalid rgid %s, using default rgid %u\n",gVars.configlinenumber,tmp,gVars.default_rgid);
                                        // Let's restore the delimiter and put back our token
                                        // this might be the next option
                                        tmp[sizeof(tmp)-1]=' ';
                                        *rules=tmp;
                                }
                                continue;
                        }
                        if(strcmp(tok,"zone")==0)
                        {
                                if((tmp = get_tok(rules,accept))==NULL)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, zone specified but none provided, using default zone %d\n",gVars.configlinenumber,gVars.default_zone);
                                        return;
                                }
		    		if((tok=search_vars(tmp,gVars.var_head,VCLASS_6))!=NULL)
			    	{
				    bzero(ptok,256);
				    strncpy(ptok,tok,sizeof(char)*strlen(tok));
				    tmp=ptok;
			    	}
                                pptr=tmp;
                                n_acl->zone = (u_int16_t) strtol(tmp,&pptr,0);
                                if(tmp==pptr)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, invalid zone %s, using default zone %d\n",gVars.configlinenumber,tmp,gVars.default_zone);
                                        // Let's restore the delimiter and put back our token
                                        // this might be the next option
                                        tmp[sizeof(tmp)-1]=' ';
                                        *rules=tmp;
                                }
                                continue;
                        }
			if(strcmp(tok,"node")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, node specified but none provided, using default node %d\n",gVars.configlinenumber,gVars.default_node);
					return;
				}
		    		if((tok=search_vars(tmp,gVars.var_head,VCLASS_7))!=NULL)
			    	{
				    bzero(ptok,256);
				    strncpy(ptok,tok,sizeof(char)*strlen(tok));
				    tmp=ptok;
			    	}
				pptr=tmp;
				n_acl->node = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)	
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid node %s, using default node %d\n",gVars.configlinenumber,tmp,gVars.default_node);
					// Let's restore the delimiter and put back our token 
					// this might be the next option
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}
			if(strcmp(tok,"status")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, status specified but none provided, using default status %d\n",gVars.configlinenumber,gVars.default_status);
					return;
				}
		    		if((tok=search_vars(tmp,gVars.var_head,VCLASS_8))!=NULL)
			    	{
				    bzero(ptok,256);
				    strncpy(ptok,tok,sizeof(char)*strlen(tok));
				    tmp=ptok;
			    	}
				pptr=tmp;
				n_acl->status = (u_int8_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)	
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid status %s, using default status %d\n",gVars.configlinenumber,tmp,gVars.default_status);
					// Let's restore the delimiter and put back our token 
					// this might be the next option
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}
			if(strcmp(tok,"timeout")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, timeout specified but none provided, using default timeout %d\n",gVars.configlinenumber,gVars.default_timeout);
					return;
				}
				pptr=tmp;
				n_acl->timeout = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid timeout %s, using default timeout\n",gVars.configlinenumber,tmp);
					// Let's restore the delimiter and put back our token 
					// this might be the next option
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}
			if(strcmp(tok,"tcplag")==0)
			{
			 	if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, tcplag specified but none provided, using default tcplag %d\n",gVars.configlinenumber,gVars.default_tcplag);
					return;
				}
				pptr=tmp;
				n_acl->tcplag = (u_int16_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid tcplag %s, using default tcplag \n",gVars.configlinenumber,tmp);
				
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}

		        if(strcmp(tok,"nosrc_pktsok")==0)
		        {
		                if((tmp = get_tok(rules,accept))==NULL)
		                {
		                        syslog(LOG_ERR,"Line: %i Format error, nosrc_pktsok specified but none provided, using nosrc_pktsok value %d\n",gVars.configlinenumber,DEFAULT_NOSRC_PKTSOK);
		                        return;
		                }
		                pptr=tmp;
		                n_acl->nosrc_pktsok = strtol(tmp,&pptr,0) ? 1 : 0 ;
		                if(tmp==pptr)
		                {
		                        syslog(LOG_ERR,"Line: %i Format error, invalid nosrc_pktsok %s, using default nosrc_pktsok %d\n",gVars.configlinenumber,tmp,DEFAULT_NOSRC_PKTSOK);
		                        n_acl->nosrc_pktsok = DEFAULT_NOSRC_PKTSOK;
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
		                }
		                continue;
		        }

			if(strcmp(tok,"limit")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, limit specified but none provided, using default limit %llu\n",gVars.configlinenumber,(long long unsigned)gVars.default_limit);
					return;
				}
				pptr=tmp;
				n_acl->limit = (u_int64_t) strtol(tmp,&pptr,0);
				if(tmp==pptr)	
				{
					syslog(LOG_ERR,"Line: %i Format error, invalid limit %s, using default limit %llu\n",gVars.configlinenumber,tmp,(long long unsigned)gVars.default_limit);
					// Let's restore the delimiter and put back our token 
					// this might be the next option
					tmp[sizeof(tmp)-1]=' ';
					*rules=tmp;
				}
				continue;
			}
                        if(strcmp(tok,"index")==0)
                        {
                                if((tmp = get_tok(rules,accept))==NULL)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, index specified but no option provided%s\n",gVars.configlinenumber,rule);
                                        return;
                                }
                                if(strcmp(tmp,"log")==0) // log all matching traffic
                                {
                                        n_acl->index = ACTION_LOG;
                                        n_acl->imode = OMODE_DEFAULT;
                                        continue;
                                }
                                if(strcmp(tmp,"pass")==0)
                                {
                                        n_acl->index = ACTION_PASS;
                                        n_acl->imode = OMODE_PASS;
                                        continue;
                                }
                                syslog(LOG_ERR,"Line: %i Skipping, invalid index option in rule: %s %s\n",gVars.configlinenumber,tok,tmp);
                                return;
                        }
			if(strcmp(tok,"realtime")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, realtime specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				if(strcmp(tmp,"log")==0) // log all matching traffic
				{
					n_acl->realtime = ACTION_LOG;
					n_acl->rmode = OMODE_DEFAULT;
					continue;
				} 
				if(strcmp(tmp,"pass")==0) 
				{
					n_acl->realtime = ACTION_PASS;
					n_acl->rmode = OMODE_PASS;
					continue;
				} 
				syslog(LOG_ERR,"Line: %i Skipping, invalid realtime option in rule: %s %s\n",gVars.configlinenumber,tok,tmp);
				return;
			} 

#ifdef ENABLE_PRELUDE_SUPPORT
                        if(strcmp(tok,"prelude")==0)
                        {
                                if((tmp = get_tok(rules,accept))==NULL)
                                {
                                        syslog(LOG_ERR,"Line: %i Format error, prelude specified but no option provided%s\n",gVars.configlinenumber,rule);
                                        return;
                                }
                                if(strcmp(tmp,"log")==0) // log all matching traffic
                                {
                                        n_acl->customoutput=ACTION_LOG;
                                        continue;
                                }
                                if(strcmp(tmp,"pass")==0)
                                {
                                        n_acl->customoutput = OMODE_PASS;
                                        continue;
                                }
                                syslog(LOG_ERR,"Line: %i Skipping, invalid prelude option in rule: %s %s\n",gVars.configlinenumber,tok,tmp);
                                return;
                        }
#endif
			if(strcmp(tok,"stats")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, stats specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				if(strcmp(tmp,"log")==0) // log all matching traffic
				{
					n_acl->stats=ACTION_LOG;
					n_acl->smode=OMODE_LOG;
					continue;
				} 
				if(strcmp(tmp,"pass")==0) 
				{
					n_acl->stats = ACTION_PASS;
					n_acl->smode = OMODE_PASS;
					continue;
				} 
				syslog(LOG_ERR,"Line: %i Skipping, invalid stats option in rule: %s %s\n",gVars.configlinenumber,tok,tmp);
				return;
			}
			if(strcmp(tok,"pcap")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, output specified but none provided, using default output %s\n",gVars.configlinenumber,rule);
					return;
				}
				if(strcmp(tmp,"log")==0) // log all matching traffic
				{
					if (gVars.pfH)
					{	
#ifdef DEBUG
						printf("rule using 0x%X ->\n",(u_int32_t)n_acl);
#endif
						if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
						n_acl->fH = gVars.pfH->attach();
						n_acl->pcap = ACTION_LOG;
						n_acl->pmode = OMODE_LOG;
						continue;
					} else {
						syslog(LOG_ERR,"Line: %i Format error, pcap log specified in rule but no default log file specified by default\n",gVars.configlinenumber);
						return;
					}
				} 
				if(strcmp(tmp,"pass")==0) 
				{
					if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
					n_acl->pcap = ACTION_PASS;
					n_acl->pmode = OMODE_PASS;
					n_acl->cmode = CMODE_NONE;
					continue;
				} 
				if(strcmp(tmp,"rule")==0) 
				{
					// FIX: added code to create rule based pcapFileHandle
					if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
					if(n_acl->pcap_fname){ free(n_acl->pcap_fname); n_acl->pcap_fname=0; }
					n_acl->pcap_fname=createPcapFileName(n_acl);
					n_acl->fH = new pcapFileHandle(n_acl->pcap_fname,gVars.ph);
					n_acl->pcap = ACTION_LOG;
					n_acl->pmode = OMODE_RULE;
					continue;
				}
				if(strcmp(tmp,"connection")==0)
				{
					if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
					n_acl->fH=0;
					n_acl->pcap = ACTION_LOG;
					n_acl->pmode = OMODE_UNIQ;
					continue;
				}
				if(strcmp(tmp,"filename")==0)
				{
					if((tmp = get_tok(rules,accept))==NULL)
					{
						syslog(LOG_ERR,"Line: %i Format error, filename specified but none provided, using default filename %s\n",gVars.configlinenumber,rule);
						return;
					}else{
						// FIX: added code to create rule based filename pcapFileHandle
						if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
						if(n_acl->pcap_fname){ free(n_acl->pcap_fname); n_acl->pcap_fname=0; }
                        			gVars.pcap_fname=(char *) calloc(1,strlen(tmp)+1);
                        			strncpy(gVars.pcap_fname,tmp,strlen(tmp));
						ftmp=createFileName(tmp,false);
						n_acl->fH = new pcapFileHandle(ftmp,gVars.ph);
						n_acl->pcap = ACTION_LOG;
						n_acl->pmode=OMODE_FILENAME;
					}
					continue;
				}
				if(strcmp(tmp,"tsfilename")==0)
				{
					if((tmp = get_tok(rules,accept))==NULL)
					{
						syslog(LOG_ERR,"Line: %i Format error, tsfilename specified but none provided, using default pcap output file%s\n",gVars.configlinenumber,rule);
						return;
					}else{
						// FIX: added code to create rule based tsfilename pcapFileHandle
						if(n_acl->fH){ n_acl->fH->destroy(); n_acl->fH=0; }
						if(n_acl->pcap_fname){ free(n_acl->pcap_fname); n_acl->pcap_fname=0; }
                        			gVars.pcap_fname=(char *) calloc(1,strlen(tmp)+1);
                        			strncpy(gVars.pcap_fname,tmp,strlen(tmp));
						// Create this filename with a timestamp
						ftmp=createFileName(n_acl->pcap_fname,true);
						n_acl->fH = new pcapFileHandle(ftmp,gVars.ph);
						free(ftmp);
						n_acl->pcap = ACTION_LOG;
						n_acl->pmode=OMODE_TSFILENAME;
					}
					continue;
				}
				syslog(LOG_ERR,"Line: %i Skipping, invalid pcap option in rule: %s %s\n",gVars.configlinenumber,tok,tmp);
				return;
			}
			if(strcmp(tok,"logdst")==0)
			{
				n_acl->cmode = CMODE_DST;
				continue;
			}
			if(strcmp(tok,"logsrc")==0)
			{
				n_acl->cmode = CMODE_SRC;
				continue;
			}
			if(strcmp(tok,"ignore")==0)
			{
				// We should ignore everything for this rule
				n_acl->stats=n_acl->realtime=n_acl->pcap=ACTION_PASS;
				n_acl->cmode = CMODE_NONE;
				n_acl->pmode = OMODE_PASS;
				continue;
			}
			if(strcmp(tok,"retro")==0)  // Apply rule to pre-existing connections in memory
			{
				n_acl->retro = true;
				continue;
			}
#ifdef ENABLE_PRELUDE_SUPPORT

			if(strcmp(tok,"prelude_impact_severity")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, prelude_impact_severity specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				n_acl->prelude_impact_severity = strdup(tmp);
				continue;
			}
			if(strcmp(tok,"prelude_impact_completion")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, prelude_impact_completion specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				n_acl->prelude_impact_completion = strdup(tmp);
				continue;
			}
			if(strcmp(tok,"prelude_impact_type")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, prelude_impact_type specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				n_acl->prelude_impact_type = strdup(tmp);
				continue;
			}
			if(strcmp(tok,"prelude_confidence_rating")==0)
			{
				if((tmp = get_tok(rules,accept))==NULL)
				{
					syslog(LOG_ERR,"Line: %i Format error, prelude_confidence_rating specified but no option provided%s\n",gVars.configlinenumber,rule);
					return;
				}
				n_acl->prelude_confidence_rating = strdup(tmp);
				continue;
			}
#endif
			syslog(LOG_ERR,"Line: %i Skipping, invalid option in rule: %s %s\n",gVars.configlinenumber, tok,*rules);
			return;
		}
		// If we made it this far, the rule is good
		// So we will add it to our list 	
		if(tacl_head){
        		tacl_tail->next=n_acl;
		}else{
			tacl_head=n_acl;
		}
        	tacl_tail=n_acl;
		if(n_acl->retro){
		#ifdef DEBUG
			printf("Applying rule retro-actively!\n");
		#endif
			retroactive(n_acl);
		}
		
}
/*
 *  char * get_tok (char **rule, const char *delimiters ) 
 *  Uses strpbrk to locate the first occurrance of a character in *delimiters, 
 *  replaces this character with a null '\0', modifying **rule to point
 *  one byte past the delimiter character.
 *
 *  Returns pointer to beginning of token, or NULL if no delimiter is found.
 *
 */
 
// Returns the rule you were pointing to and modifies rule
char * get_tok(char **rule, const char *delimiters)
{
	char *tok=*rule;
	char *tmp=0;
	int len=0;
	if(*rule==NULL)
		return NULL;
	len=strlen(tok); 
	
	if((tmp = strpbrk(*rule,delimiters))!=NULL){
		*tmp=0;
		if(tmp>*rule)
			*rule=++tmp;
	} else {
		*rule=NULL;
	}
	return tok;
}

// Returns next tok or NULL
char * get_next_tok(char **rule, const char *delimiters)
{
	char *tok=*rule;
	char *tmp;
	int len=0;
	if(*rule==NULL)
		return NULL;
	len=strlen(tok);

	if((tmp = strpbrk(*rule,delimiters))!=NULL){
		*tmp='\0';
		if(tmp>*rule)
			*rule=++tmp;
		return tok;
	} else {
		return NULL;
	}
}


void print_acl(int a){
	extern struct gvars gVars;
        extern char fmtnames[MAXFLDS][MAXFLDSIZE];
	struct t_ports *tmp_port;
	struct t_ports *ports_head;
	char currenttime[80];
        time_t timestr=gVars.timeptr.tv_sec;
        struct acl* tmpptr;
	int p, cidr,bits;
	char ptok[256];
	char tmpptok[256];
	char *tmp;
	u_int32_t tmpint;
        int tsize=1024;
	char LOG[tsize];
	char TMPLOG[tsize];
	tmpptr=gVars.acl_head;
 	if(gVars.uselocaltime){
	        strftime(currenttime,80,"%Y-%m-%d %T",(struct tm *)localtime(&timestr));
	}else{
        	strftime(currenttime,80,"%Y-%m-%d %T GMT",(struct tm *)gmtime(&timestr));
	}
        if(gVars.sdF){ gVars.sdF->destroy(); gVars.sdF=NULL; }
        if(!gVars.sdF){
                tmp=createFileName(gVars.console_fname,false);
                gVars.sdF = new outputFileHandle(tmp,gVars.console_fmt,gVars.console_fmt_len,APPEND_MODE,gVars.console_fname);
                //gVars.sdF = new outputFileHandle(stdout,APPEND_MODE,gVars.console_fmt,gVars.console_fmt_len);
                gVars.sdF->setFormat(gVars.console_fmt,gVars.console_fmt_len);
                gVars.sdF->setEor(gVars.console_eor);
	        gVars.sdF->setWildchar(gVars.console_wildchar);
                gVars.sdF->setDelimiter(gVars.console_delimiter);
                free(tmp);
        }
        bzero(LOG,tsize);
	char *spacer="\n\n";

	sprintf(LOG,"#\n#  Running configuration as of %s  (sancp %s)\n#\n",currenttime,VERSION);
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	sprintf(LOG,"# Output formats\n#\n");
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	if(gVars.sfH){
	gVars.sfH->printFormat(LOG,tsize,(char **)&fmtnames,MAXFLDS,MAXFLDSIZE);
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	gVars.sdF->write(spacer,strlen(spacer)); 
	}

	if(gVars.rfH){
	gVars.rfH->printFormat(LOG,tsize,(char **)&fmtnames,MAXFLDS,MAXFLDSIZE);
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	gVars.sdF->write(spacer,strlen(spacer)); 
	}

	if(gVars.ifH){
	gVars.ifH->printFormat(LOG,tsize,(char **)&fmtnames,MAXFLDS,MAXFLDSIZE);
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	gVars.sdF->write(spacer,strlen(spacer)); 
	}

	gVars.sdF->printFormat(LOG,tsize,(char **)&fmtnames,MAXFLDS,MAXFLDSIZE);
	gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	gVars.sdF->write(spacer,strlen(spacer)); 


	char type[10][36]={ {"Unused or unassociated vars"},{"Ethernet protocols"},{"Networks and hosts"},{"IP protocols"},{"UDP/TCP ports"},{ "rule ids (rid)"},{"rule group ids (rgid) "},{"zones"},{"nodes"},{"status"}};

	int unused=0;

	struct vars *tvars=gVars.var_head;

	for(int x=1; x<10; x++){
		sprintf(LOG,"\n#\n# defined %s\n#\n",type[x]); 
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	        while(tvars!=NULL){ 
			if(tvars->vclass==x){
				sprintf(LOG,"var %s %s\n",tvars->key,tvars->value); 
		       		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
			}
			if(tvars->vclass==0){ unused=1; }
			tvars=tvars->next; 
		} 
		tvars=gVars.var_head;
	}

	if(unused){
		sprintf(LOG,"\n#\n# %s\n#\n",type[0]); 
      		//LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	        while(tvars!=NULL){ 
			if(tvars->vclass==0){
				sprintf(LOG,"var %s %s\n",tvars->key,tvars->value); 
		       		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
			}
			tvars=tvars->next; 
		} 
	}

	sprintf(LOG,"\n#\n# defined defaults\n#\n"); 
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	if(gVars.imode==OMODE_FILENAME && gVars.imode!=OMODE_PASS){
		sprintf(LOG,"default index filename %s\n",gVars.index_fname);
	}else if(gVars.rmode==OMODE_TSFILENAME && gVars.imode!=OMODE_PASS){
		sprintf(LOG,"default index tsfilename %s\n",gVars.index_fname);
	}else{
		sprintf(LOG,"default index %s\n",gVars.imode?"log":"pass");
	}
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	if(gVars.rmode==OMODE_FILENAME  && gVars.rmode!=OMODE_PASS){
		sprintf(LOG,"default realtime filename %s\n",gVars.realtime_fname);
	}else if(gVars.rmode==OMODE_TSFILENAME && gVars.rmode!=OMODE_PASS){
		sprintf(LOG,"default realtime tsfilename %s\n",gVars.realtime_fname);
	}else{
		sprintf(LOG,"default realtime %s\n",gVars.rmode?"log":"pass");
	}
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	if(gVars.smode==OMODE_FILENAME  && gVars.smode!=OMODE_PASS){
		sprintf(LOG,"default stats filename %s\n",gVars.stats_fname);
	}else if(gVars.smode==OMODE_TSFILENAME  && gVars.smode!=OMODE_PASS){
		sprintf(LOG,"default stats tsfilename %s\n",gVars.stats_fname);
	}else{
		sprintf(LOG,"default stats %s\n",gVars.smode?"log":"pass");
	}
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	if(gVars.pmode==OMODE_FILENAME  && gVars.pmode!=OMODE_PASS){
		sprintf(LOG,"default pcap filename %s\n",gVars.pcap_fname);
	}else if(gVars.pmode==OMODE_TSFILENAME && gVars.pmode!=OMODE_PASS){
		sprintf(LOG,"default pcap tsfilename %s\n",gVars.pcap_fname);
	}else{
		sprintf(LOG,"default pcap %s\n",gVars.pmode?"log":"pass");
	}
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
#ifdef ENABLE_PRELUDE_SUPPORT
	sprintf(LOG,"default prelude %s\n",gVars.customoutput?"log":"pass");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
#endif
	sprintf(LOG,"default strip_8021Q %s\n",gVars.strip_8021Q?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default flush_interval %u\n",gVars.default_flush_interval);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default expire_interval %u\n",gVars.default_expire_interval);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default burst_mode %s\n",gVars.burst_mode?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default status %u\n",gVars.default_status);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default node %u\n",gVars.default_node);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default zone %u\n",gVars.default_zone);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default rid %u\n",gVars.default_rid);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default rgid %u\n",gVars.default_rgid);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default timeout %d\n",gVars.default_timeout);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default console %s\n",gVars.console_fname);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	sprintf(LOG,"default sample_src_length %u\n",gVars.default_sample_length[FROM_INITIATOR]);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default sample_dst_length %u\n",gVars.default_sample_length[FROM_TARGET]);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	sprintf(LOG,"default limit %llu\n",(long long unsigned)gVars.default_limit);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default tcplag %d\n",gVars.default_tcplag);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default debug_pcap_raw %s\n",gVars.pcap_raw?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default arprarp_decode %s\n",gVars.arprarp_decode?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"default use_icmp_mixed %s\n",gVars.log_icmp_type_code?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	sprintf(LOG,"\n#\n# read-only / command-line configuration defaults\n#\n"); 
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"#global daemon_mode %s\n",gVars.daemon_mode?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"#global use_local_time %s\n",gVars.uselocaltime?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"#global shift %s\n",gVars.shift?"enable":"disable");
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	sprintf(LOG,"#global pcapfilter %s\n",gVars.bpf_filter);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	sprintf(LOG,"\n#\n# defined known_ports\n#\n"); 
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

	for(p=0; p<MAX_IP_PROTO; p++)
	{
		ports_head=gVars.ports[p];
		if(ports_head!=NULL)
		{
			strcat(LOG,"known_ports");

			bzero(ptok,256);
			sprintf(ptok,"%d",p);
	
			//
			// Retrieve name of known_ports protocol
			//

			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_2))!=NULL)
			{
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			bzero(TMPLOG,tsize);
			strncpy(TMPLOG,LOG,sizeof(char)*strlen(LOG));
			bzero(LOG,tsize);
			sprintf(LOG,"%s %s ",TMPLOG,ptok);

			//
			// Search all ports 
			//

			while(ports_head!=NULL){ 
				tmp_port=ports_head;
				ports_head=tmp_port->next;
				bzero(ptok,256);
				sprintf(ptok,"%d",tmp_port->l_port);
				if(tmp_port->l_port!=tmp_port->h_port) { 
					bzero(tmpptok,256);
					sprintf(tmpptok,"%s-%d",ptok,tmp_port->h_port);
					strncpy(ptok,tmpptok,sizeof(char)*strlen(tmpptok));
				}
				//
				// Locate name of port
				//
				if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_3))!=NULL)
				{
					bzero(ptok,256);
					strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
				}
				bzero(TMPLOG,tsize);
				strncpy(TMPLOG,LOG,sizeof(char)*strlen(LOG));
				bzero(LOG,tsize);
				sprintf(LOG,"%s%s",TMPLOG,ptok);
				if(tmp_port->next) strcat(LOG,",");
			}
			strcat(LOG,"\n");
			LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
		}
	}

	sprintf(LOG,"\n#\n#  Running rules as of %s\n#\n",currenttime);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	while(tmpptr!=NULL){
		//
		//  ETHPROTO   (VCLASS_0)
		//
		
		bzero(ptok,256);
		if(tmpptr->h_proto_l==tmpptr->h_proto_h){	
			sprintf(ptok,"%d",tmpptr->h_proto_l);
		}else{
			sprintf(ptok,"%d-%d",tmpptr->h_proto_l,tmpptr->h_proto_h);
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_0))!=NULL){
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->h_proto_l==0 && tmpptr->h_proto_h==0xFFFF ){
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s ",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
		
		//
		//  SOURCE IP (VCLASS_1)
		//
	
		bzero(ptok,256);
		sprintf(ptok,"%s",inet_ntoa(*(struct in_addr*) &tmpptr->s_ip));
		if(tmpptr->s_mask!=0xFFFFFFFF){
			tmpint = htonl(tmpptr->s_mask);
			cidr=bits=0;
			while((tmpint&0xC0000000)!=0x40000000){
				bits++;
				if((tmpint&0xC0000000)!=0xC0000000){ cidr=bits; break; }
				tmpint<<=1;
			}
			if(htonl(tmpptr->s_mask)==(u_int32_t)(0xFFFFFFFF<<(32-cidr))){
			   sprintf(ptok,"%s/%d",ptok,cidr);
			}else{
			   sprintf(ptok,"%s/%s",ptok,inet_ntoa(*(struct in_addr*) &tmpptr->s_mask));
			}
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_1))!=NULL) {
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->s_ip==0){
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s ",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

		//
		//  DESTINATION IP (VCLASS_1)
		//
		
		bzero(ptok,256);
		sprintf(ptok,"%s",inet_ntoa(*(struct in_addr*) &tmpptr->d_ip));
		if(tmpptr->d_mask!=0xFFFFFFFF){
			tmpint = htonl(tmpptr->d_mask);
			cidr=bits=0;
			while((tmpint&0xC0000000)!=0x40000000){
				bits++;
				if((tmpint&0xC0000000)!=0xC0000000){ cidr=bits; break; }
				tmpint<<=1;
			}
			if(htonl(tmpptr->d_mask)==(u_int32_t)(0xFFFFFFFF<<(32-cidr))){
			   sprintf(ptok,"%s/%d",ptok,cidr);
			}else{
			   sprintf(ptok,"%s/%s",ptok,inet_ntoa(*(struct in_addr*) &tmpptr->d_mask));
			}
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_1))!=NULL) {
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->d_ip==0){
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s ",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

		//
		//  IPPROTO (VCLASS_2)
		//
		
		bzero(ptok,256);
		sprintf(ptok,"%d",tmpptr->proto_l);
		if(tmpptr->proto_l!=tmpptr->proto_h){	
			sprintf(ptok,"%s-%d",ptok,tmpptr->proto_h);
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_2))!=NULL) {
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->proto_l==0x00 && tmpptr->proto_h==0xFF){	
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s ",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

		//
		//  Source TCP_UDP_PORT (VCLASS_3)
		//
		
		bzero(ptok,256);
		sprintf(ptok,"%d",tmpptr->s_port_l);
                if(tmpptr->s_port_l!=tmpptr->s_port_h){
			sprintf(ptok,"%s-%d",ptok,tmpptr->s_port_h);
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_2))!=NULL) {
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->s_port_l==0 && tmpptr->s_port_h==0xFFFF){	
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s ",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

		//
		//  Destination TCP_UDP_PORT (VCLASS_3)
		//
		
		bzero(ptok,256);
		sprintf(ptok,"%d",tmpptr->d_port_l);
                if(tmpptr->d_port_l!=tmpptr->d_port_h){
			sprintf(ptok,"%s-%d",ptok,tmpptr->d_port_h);
		}
		if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_2))!=NULL) {
			bzero(ptok,256);
			strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
		}else if(tmpptr->d_port_l==0 && tmpptr->d_port_h==0xFFFF){	
			bzero(ptok,256);
			strncpy(ptok,"any",sizeof(char)*strlen("any"));
		}
		sprintf(LOG,"%s",ptok);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);

		//
		//  Logging options 
		//

		if(!tmpptr->stats && !tmpptr->realtime && !tmpptr->pcap){
		// no logging options are enabled
		   strcat(LOG,", ignore");
		}else{
		//
		// Only display logging actions that differ from the default logging actions
		//
		//
		// STATS
		//
		   if(tmpptr->stats!=gVars.smode){
   		      strcat(LOG,", stats");
		      if(tmpptr->smode==OMODE_PASS)
			strcat(LOG,"=pass");
		      else if(tmpptr->smode==OMODE_LOG)
			strcat(LOG,"=log");
		   }
		//
		// INDEX
		//
		   if(tmpptr->index!=gVars.imode){
		      strcat(LOG,", index");
		      if(tmpptr->imode==OMODE_PASS)
			strcat(LOG,"=pass");
		      else if(tmpptr->imode==OMODE_LOG)
			strcat(LOG,"=log");
		   }
#ifdef ENABLE_PRELUDE_SUPPORT
	//
	// PRELUDE
	//
	   if(tmpptr->customoutput!=gVars.customoutput){
	      strcat(LOG,", prelude");
	      if(tmpptr->customoutput==OMODE_PASS)
		strcat(LOG,"=pass");
	      else if(tmpptr->customoutput==OMODE_LOG)
		strcat(LOG,"=log");
	   }
#endif
		//
		// REALTIME
		//
		   if(tmpptr->realtime!=gVars.rmode){
		      strcat(LOG,", realtime");
		      if(tmpptr->rmode==OMODE_PASS)
			strcat(LOG,"=pass");
		      else if(tmpptr->rmode==OMODE_LOG)
			strcat(LOG,"=log");
		   }
		//
		// PCAP
		//
		   if(tmpptr->pmode!=gVars.pmode){
		      strcat(LOG,", pcap");
		      if(tmpptr->pmode==OMODE_PASS)
			strcat(LOG,"=pass");
		      else if(tmpptr->pmode==OMODE_LOG)
			strcat(LOG,"=log");
		      else if(tmpptr->pmode==OMODE_RULE)
			strcat(LOG,"=rule");
		      else if(tmpptr->pmode==OMODE_UNIQ)
			strcat(LOG,"=connection");
		      else if(tmpptr->pmode==OMODE_FILENAME && gVars.pfH->getFileHandle()!=tmpptr->fH->getFileHandle())
			sprintf(LOG,"%s filename=%s",LOG,tmpptr->fH->getFileName());
		      else if(tmpptr->pmode==OMODE_TSFILENAME)
			sprintf(LOG,"%s tsfilename=%s",LOG,tmpptr->fH->getFileName());
		   }
		 //
		 // Half-stream direction collection flag 
		 //  
		   if(tmpptr->cmode==CMODE_SRC)
			strcat(LOG,", logsrc");
		   if(tmpptr->cmode==CMODE_DST)
			strcat(LOG,", logdst");
		}

		//
		// REMAINING OPTIONS
		//

		// LIMIT
		if(tmpptr->limit!=gVars.default_limit)
			sprintf(LOG,"%s, limit=%llu",LOG,(long long unsigned)tmpptr->limit);
		// TIMEOUT
		if(tmpptr->timeout!=gVars.default_timeout)
			sprintf(LOG,"%s, timeout=%d",LOG,tmpptr->timeout);
		// TCPLAG
		if(tmpptr->tcplag!=gVars.default_tcplag)
			sprintf(LOG,"%s, tcplag=%d",LOG,tmpptr->tcplag);
		// RID   VCLASS_4
		if(tmpptr->rid)
		{
			bzero(ptok,256);
			sprintf(ptok,"%u",tmpptr->rid);
			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_4))!=NULL) {
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			sprintf(LOG,"%s, rid=%s",LOG,ptok);
		}
		// RGID VCLASS_5
		if(tmpptr->rgid)
		{
			bzero(ptok,256);
			sprintf(ptok,"%u",tmpptr->rgid);
			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_5))!=NULL) {
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			sprintf(LOG,"%s, rgid=%s",LOG,ptok);
		}
		// ZONE VCLASS_6
		if(tmpptr->zone)
		{
			bzero(ptok,256);
			sprintf(ptok,"%u",tmpptr->zone);
			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_6))!=NULL) {
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			sprintf(LOG,"%s, zone=%s",LOG,ptok);
		}
		// NODE VCLASS_7
		if(tmpptr->node)
		{
			bzero(ptok,256);
			sprintf(ptok,"%u",tmpptr->node);
			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_7))!=NULL) {
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			sprintf(LOG,"%s, node=%s",LOG,ptok);
		}
		// STATUS VCLASS_8
		if(tmpptr->status!=gVars.default_status)
		{
			bzero(ptok,256);
			sprintf(ptok,"%u",tmpptr->status);
			if((tmp=rev_search_vars(ptok,gVars.var_head,VCLASS_8))!=NULL) {
				bzero(ptok,256);
				strncpy(ptok,tmp,sizeof(char)*strlen(tmp));
			}
			sprintf(LOG,"%s, status=%s",LOG,ptok);
		}
		// RETRO
		if(tmpptr->retro)
			strcat(LOG,", retro");

		// DEFAULT RULE MATCHES
		sprintf(LOG,"%s # Matches: %d\n",LOG,tmpptr->ctr);

		tmpptr=tmpptr->next;
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	}
	sprintf(LOG,"# Implicit rule matches: %d\n",gVars.default_ctr);
	LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	if(gVars.username || gVars.groupname){
		sprintf(LOG,"# Running as: %s:%s\n",gVars.username,gVars.groupname);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	}
	if(gVars.config_file){
		sprintf(LOG,"# Configuration file: %s \n",gVars.config_file?gVars.config_file:"CWD");
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	}
	if(gVars.log_directory){
		sprintf(LOG,"# Output directory: %s \n",gVars.log_directory);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	}
	if(gVars.input_filename){
		sprintf(LOG,"# Reading from file: %s \n",gVars.input_filename);
		LOG[tsize-1]='\0'; gVars.sdF->write(LOG,strlen(LOG)); bzero(LOG,tsize);
	}

}

void license()
{
	//fprintf(stdout,"\n -- Released under the QPL LICENSE --\n \n Copyright (C) 2003-2007 John Curry <john.curry@metre.net>\n \n No Warranty Expressed or Implied\n ");
	fprintf(stdout,"\n %s \n \n %s \n \n %s \n ",QUOTELICENSE,QUOTECOPYRIGHT,QUOTEWARRENTY);
}

void version()
{
	fprintf(stdout," Security Analyst Network Connection Profiler v %s\n",VERSION);
}

void set_bpf_filter(char *argv)
{
        extern struct gvars gVars;
        long len;

	if(gVars.bpf_fname){ free(gVars.bpf_fname); }
       	gVars.bpf_fname=(char *) calloc(1,strlen(argv)+1);
       	strncpy(gVars.bpf_fname,argv,strlen(argv));
	if(gVars.bfH){ gVars.bfH->destroy(); gVars.bfH=0; }
	gVars.bfH = new fileHandle(gVars.bpf_fname);
        gVars.bfH->setMode(READ_MODE);
        gVars.bfH->seek(0,SEEK_END);
        len=gVars.bfH->tell();
        if(gVars.bpf_filter){ free(gVars.bpf_filter); }
        if((gVars.bpf_filter = (char *) calloc(1,len+1))==NULL)
        {
#ifdef DEBUG
                syslog(LOG_CRIT,"Out of memory - bpf filter too big?\n");
                return;
#endif
        }
        gVars.bfH->seek(0,0);
        gVars.bfH->close();
        gVars.bfH->setMode(READ_MODE);
        if(gVars.bfH->read(gVars.bpf_filter,len)==-1)
        {
                switch (errno){
                case EINTR:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EINTR\n",gVars.configlinenumber);
                       break;
                case EAGAIN:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EAGAIN\n",gVars.configlinenumber);
                       break;
                case EIO:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EIO\n",gVars.configlinenumber);
                       break;
                case EISDIR:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EISDIR\n",gVars.configlinenumber);
                       break;
                case EBADF:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EBADF\n",gVars.configlinenumber);
                       break;
                case EINVAL:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EINVAL\n",gVars.configlinenumber);
                       break;
                case EFAULT:
                        syslog(LOG_ERR,"Line: %i Error reading bpf filter: EFAULT\n",gVars.configlinenumber);
                       break;
                }
        }
        if(gVars.bpf_filter[len-1]=='\n')
        	gVars.bpf_filter[len-1]=0;
	/* We'll get rid of bpF here - close_files()
	 * is not a good place for this right now
	 * cause it gets called by reload_config()
	 * and that may be confusing, until we can apply
	 * new bpf filters -after- start-up
	 */
        if(gVars.bfH){ gVars.bfH->destroy(); gVars.bfH=NULL; }
	
}
